/*jshint bitwise:true, browser:true, curly:true, eqeqeq:true, noarg:true, noempty:true, strict:true, undef:true, unused:true, strict: false, esversion: 11 */
/*jshint quotmark:false*/
/*global $*/

var icApi;

$(document).ready(function() {

	
	// ================================= LOGIN ===========================================
	$("form[name='formLogin']").find("#submitButton").bind("click", function() {
		icApi =  new inConcertApi(document.forms.formLogin.elements.dominio.value);
		var usuario  = document.forms.formLogin.elements.usuario.value;
		var password  = document.forms.formLogin.elements.password.value;
		icApi.Login(usuario, password, function(status, response) { 
			if (status) {
				document.forms.formLogin.elements.result.value = icApi.accessToken;
			} else {
				document.forms.formLogin.elements.result.value = response;
			}
		});
		return false;
	});

	// ================================= API DEFINITION ===========================================
	$("#apiDefinitionLoad").bind("click", function() {
		const $type = $("#apiDefinitionType");
		const $result = $("#apiDefinitionResult");
		icApi.API_definition($type.val(), function(status, response) { 
			$result.val(JSON.stringify(response));
		});
		return false;
	});

	// ================================= VCC  ===========================================
	$("#currentVCCILoad").bind("click", function() {
		const $result = $("#currentVCCInfo");
		icApi.GetVCC(function(status, response) { 
			$result.val(JSON.stringify(response));
		});
		return false;
	});

	// ================================= REPORTS ===========================================
	//
	$("#rpt_execute").bind("click", function() {
		const rptId = $("#rptId").val();
		const $rpt_filter = $("#rpt_filter");
		let request = JSON.parse($rpt_filter.val());
		// let queryFields = JSON.parse($rpt_filter.val());
		// let request = {
		// 	"utc_offset": 180,
		// 	"executed_by_user": true,
		// 	"resultSize": 20,
		// 	"firstKey": "",
		// 	"queryFields": queryFields,
		// 	"last_handle": null,
		// 	"pending_fields": [
		// 		"VCC"
		// 	]
		// };
		const $rpt_execute_result = $("#rpt_execute_result");
		icApi.ReportsExecute(rptId, request, function(status, response) { 
			$rpt_execute_result.text(JSON.stringify(response));
		});
		return false;
	});	 

	// ================================= BATCHES ===========================================
	$("form[name='formBatches']").find("#submitGetAccountTemplateMessages").bind("click", function() {				
		
		var type  = document.forms.formBatches.elements.typeHSM.value;
		var campaign  = document.forms.formBatches.elements.campaignHSM.value;
		var account_name  = document.forms.formBatches.elements.accountHSM.value;
		
		var request = {type:type,campaign:campaign,account_name:account_name};
		
		icApi.GetAccountTemplateMessages(request, function(status, /*response*/) { 
			document.forms.formBatches.elements.resultHSM.value = status;
		});
		return false;
	});	
	
	$("form[name='formBatches']").find("#submitCreateBatch").bind("click", function() {		
	
		document.forms.formBatches.elements.resultCreateBatch.value = "" ;
		var type  = document.forms.formBatches.elements.typeCreate.value;
		var campaign  = document.forms.formBatches.elements.campaignCreate.value;
		var account  = document.forms.formBatches.elements.accountCreate.value;
		var batchId  = document.forms.formBatches.elements.batchIdCreate.value;
		var addresses = {0:{address:document.forms.formBatches.elements.addressCreate.value}} ;
		var asyncSend = (document.forms.formBatches.elements.asyncCreate.value === 'true');
		var message  =  { text : document.forms.formBatches.elements.messageCreate.value };
		
		var request = {type:type,campaign:campaign,account:account,batchId:batchId,addresses:addresses,message:message,async:asyncSend};
		
		icApi.CreateBatch(request, function(status, response) { 
			document.forms.formBatches.elements.resultCreateBatch.value = JSON.stringify(response);
		});
		return false;
	});	
	
	$("form[name='formBatches']").find("#submitCreateBatchHSM").bind("click", function() {				
		
		document.forms.formBatches.elements.resultCreateBatch.value = "";
		var type  = document.forms.formBatches.elements.typeCreateHSM.value;
		var campaign  = document.forms.formBatches.elements.campaignCreateHSM.value;
		var account  = document.forms.formBatches.elements.accountCreateHSM.value;
		var batchId  = document.forms.formBatches.elements.batchIdCreateHSM.value;
		var addresses = {0:{address:document.forms.formBatches.elements.addressCreateHSM.value} } ;
		var requestHSM = { groupId: "b03448ec_e7b7_41a1_b28c_bd067d514531", id: "inconcert_test", text: "Gracias por contactar nuestra empresa {{1}}", language: "es", parameters: ["IC"], hsm_buttons: [{"payload":"Pay_1","type":"quick_reply"}, {"payload":"Pay_2","type":"quick_reply"}]};
		var message  =  icApi.MakeTemplateMessage(requestHSM);
		
		var request = {type:type,campaign:campaign,account:account,batchId:batchId,addresses:addresses,message:message};
		
		icApi.CreateBatch(request, function(status, /*response*/) { 
			document.forms.formBatches.elements.resultCreateBatchHSM.value = status;
		});
		return false;
	});	
	
	$("form[name='formBatches']").find("#submitAddAddressToBatch").bind("click", function() {				
		
		document.forms.formBatches.elements.resultAddAddressToBatch.value = "";
		var type  = document.forms.formBatches.elements.type.value;
		var campaign  = document.forms.formBatches.elements.campaign.value;
		var account  = document.forms.formBatches.elements.account.value;
		var batchId  = document.forms.formBatches.elements.batchid.value;
		var address  = document.forms.formBatches.elements.address.value;
		var asyncSend = (document.forms.formBatches.elements.asyncAddAddressToBatch.value === 'true');
		
		var request = {type:type,campaign:campaign,account:account,batchId:batchId,address:address,async:asyncSend};
		
		icApi.AddAddressToBatch(request, function(status, /*response*/) { 
			document.forms.formBatches.elements.resultAddAddressToBatch.value = status;
		});
		return false;
	});	

	$("form[name='formBatches']").find("#submitSearchBatches").bind("click", function() {				
		
		var type  = document.forms.formBatches.elements.typeSearchBatches.value;
		var campaign  = document.forms.formBatches.elements.campaignSearchBatches.value;
		var state  = document.forms.formBatches.elements.stateSearchBatches.value;
		
		var query = {type:type,campaign:campaign};
		var request = {view:state,query:query};
		
		icApi.SearchBatches(request, function(status, response) { 
			document.forms.formBatches.elements.resultSearchBatches.value = JSON.stringify(response);
		});
		return false;
	});	
	 
	$("form[name='formBatches']").find("#submitGetBatch").bind("click", function() {				
		
		var campaign  = document.forms.formBatches.elements.campaignGetBatch.value;
		var account  = document.forms.formBatches.elements.accountGetBatch.value;
		var batchId  = document.forms.formBatches.elements.batchIdGetBatch.value;
		
		var request = {campaign:campaign,account_name:account,batchId:batchId};
		
		icApi.GetBatch(request, function(status, response) { 
			document.forms.formBatches.elements.resultGetBatch.value = JSON.stringify(response);
		});
		return false;
	});	 
								
	$("form[name='formBatches']").find("#submitGetBatchAddress").bind("click", function() {
	
		document.forms.formBatches.elements.resultGetBatchAddress.value = "";
		var campaign  = document.forms.formBatches.elements.campaignGetBatchAddress.value;
		var account  = document.forms.formBatches.elements.accountGetBatchAddress.value;
		var batchId  = document.forms.formBatches.elements.batchIdGetBatchAddress.value;
		var address  = document.forms.formBatches.elements.AddressGetBatchAddress.value;
		var request = {campaign:campaign,account_name:account,batchId:batchId,address:address};
		
		icApi.GetBatchAddress(request, function(status, response) { 
			document.forms.formBatches.elements.resultGetBatchAddress.value = JSON.stringify(response);
		});
		return false;
	});	
	
	$("form[name='formBatches']").find("#submitGetBatchAddresses").bind("click", function() {				
		
		document.forms.formBatches.elements.resultGetBatchAddresses.value = "";
		var campaign  = document.forms.formBatches.elements.campaignGetBatchAddresses.value;
		var account  = document.forms.formBatches.elements.accountGetBatchAddresses.value;
		var batchId  = document.forms.formBatches.elements.batchIdGetBatchAddresses.value;
		
		//Si se quiere pasar una lista de Address:
		//var addresses  = ["59899925895","59899925896"];
		//var request = {campaign:campaign,account_name:account,batchId:batchId,addresses:addresses};
		
		var request = {campaign:campaign,account_name:account,batchId:batchId};
		
		icApi.GetBatchAddresses(request, function(status, response) { 
			document.forms.formBatches.elements.resultGetBatchAddresses.value = JSON.stringify(response);
		});
		return false;
	});	
	
	$("form[name='formBatches']").find("#submitSearchBatchAddresses").bind("click", function() {				
		
		document.forms.formBatches.elements.resultSearchBatchAddresses.value = "";
		var campaign  = document.forms.formBatches.elements.campaignSearchBatchAddresses.value;
		var account  = document.forms.formBatches.elements.accountSearchBatchAddresses.value;
		var batchId  = document.forms.formBatches.elements.batchIdSearchBatchAddresses.value;
		var limit = document.forms.formBatches.elements.limitSearchBatchAddresses.value;
		var numberPage= document.forms.formBatches.elements.numberPageSearchBatchAddresses.value;
		var sort= document.forms.formBatches.elements.sortSearchBatchAddresses.value;
		var desc= document.forms.formBatches.elements.descSearchBatchAddresses.value === "true";
		//var query = {status: "SENT"};
		var query = {numberPage: 1, limit: 2};
		var request = {campaign:campaign,account_name:account,batchId:batchId, limit:limit, numberPage:numberPage, sort:sort, desc:desc, query:query};
		
		icApi.SearchBatchAddresses(request, function(status, response) { 
			document.forms.formBatches.elements.resultSearchBatchAddresses.value = JSON.stringify(response);
		});
		return false;
	});	
// ================================= CAMPAIGNS ===========================================
	$("form[name='formCampaigns']").find("#submitButtonGetCampaign").bind("click", function() {				
		
		icApi.GetCampaign(document.forms.formCampaigns.elements.campaign.value, function(status, response) { 
			document.forms.formCampaigns.elements.resultGetCampaign.value = JSON.stringify(response);
		});
		return false;
	});	
	
	$("form[name='formCampaigns']").find("#submitButtonSearchCriteria").bind("click", function() {				
		
		var request = {query:{Id:document.forms.formCampaigns.elements.SearchCriteria.value}};
		icApi.SearchCampaigns(request, function(status, /*response*/) { 
			document.forms.formCampaigns.elements.resultSearchCriteria.value = status;
		});
		return false;
	});	
	$("form[name='formCampaigns']").find("#submitGetCampaignDispositions").bind("click", function() {				
		
		icApi.GetCampaignDispositions(document.forms.formCampaigns.elements.GetCampaignDispositions.value, function(status, /*response*/) { 
			document.forms.formCampaigns.elements.resultGetCampaignDispositions.value = status;
		});
		return false;
	});	
	
	$("form[name='formCampaigns']").find("#submitGetCampaignMembers").bind("click", function() {
		var varCampaigns = ["Campwhatsapp","campchat1"];
		var request = {campaigns:varCampaigns};
		//var request = {};
		icApi.GetCampaignMembers(request, function(status, response) { 
			document.forms.formCampaigns.elements.resultGetCampaignMembers.value = JSON.stringify(response);
		});
		return false;
	});	 
// ================================= GROUPS ===========================================
	$("form[name='formGroups']").find("#submitGetGroups").bind("click", function() {				
		
		icApi.GetGroups(document.forms.formGroups.elements.groupPermission.value, function(status, /*response*/) { 
			document.forms.formGroups.elements.resultGetGroups.value = status;
		});
		return false;
	});		
	
// ================================= USERS ===========================================
	$("form[name='formUsers']").find("#submitGetUser").bind("click", function() {				
		
		icApi.GetUser(document.forms.formUsers.elements.user.value, function(status, /*response*/) { 
			document.forms.formUsers.elements.resultGetUser.value = status;
		});
		return false;
	});	
	
	$("form[name='formUsers']").find("#submitButtonSearchCriteria").bind("click", function() {				
		
		var request = {query:{}};
		if (document.forms.formUsers.elements.SearchCriteriaId.value !== "") {
			request.query.Id = document.forms.formUsers.elements.SearchCriteriaId.value;
		}
		if (document.forms.formUsers.elements.SearchCriteriaInteraction.value !== "") {
			request.query.Application = JSON.parse(document.forms.formUsers.elements.SearchCriteriaInteraction.value);
		}
		if (document.forms.formUsers.elements.SearchCriteriaStatus.value !== "") {
			request.query.Status = document.forms.formUsers.elements.SearchCriteriaStatus.value;
		}
		if (document.forms.formUsers.elements.SearchLimit.value !== "") {
			request.limit = document.forms.formUsers.elements.SearchLimit.value;
		}
		if (document.forms.formUsers.elements.SearchPage.value !== "") {
			request.numberPage = document.forms.formUsers.elements.SearchPage.value;
		}
		//var request = {query:{Id:document.forms.formUsers.elements.SearchCriteriaAgent.value, Application: document.forms.formUsers.elements.SearchCriteriaInteraction.value}};
		icApi.SearchUsers(request, function(status, response) { 
			document.forms.formUsers.elements.resultSearchCriteria.value = JSON.stringify(response);
		});
		return false;
	});	
	
	$("form[name='formUsers']").find("#submitGetAvailableTelephonyPeers").bind("click", function() {				
		
		
		icApi.GetAvailableTelephonyPeers(function(status, response) { 
			document.forms.formUsers.elements.resultGetAvailableTelephonyPeers.value = response;
		});
		return false;
	});	
	
	$("form[name='formUsers']").find("#submitSaveUser").bind("click", function() {				
		
		var IdSaveUser =  document.forms.formUsers.elements.IdSaveUser.value;
		var PassSaveUser =  document.forms.formUsers.elements.PassSaveUser.value;
		var NameSaveUser =  document.forms.formUsers.elements.NameSaveUser.value;
		var FirstSurnameSaveUser =  document.forms.formUsers.elements.FirstSurnameSaveUser.value;
		var UserGroupSaveUser =  document.forms.formUsers.elements.UserGroupSaveUser.value;
		var DefaultCampaignSaveUser =  document.forms.formUsers.elements.DefaultCampaignSaveUser.value;
		var TimeZoneId =  document.forms.formUsers.elements.TimeZoneIdSaveUser.value;
		var countryCode =  document.forms.formUsers.elements.countryCodeSaveUser.value;
		var vMail = document.forms.formUsers.elements.mailSaveUser.value;
		var groups =  [{id:document.forms.formUsers.elements.CampaignsSaveUser.value , role:"agent"}];
		var vPeer = {peer:{peer:document.forms.formUsers.elements.peerNumberSaveUser.value,service:document.forms.formUsers.elements.peerServiceSaveUser.value,technology:document.forms.formUsers.elements.peerTechnologySaveUser.value}};
		
		var request = {Id:IdSaveUser,isNew:true,Password:PassSaveUser,Name:NameSaveUser,FirstSurname:FirstSurnameSaveUser,Mail:vMail,UserGroup:UserGroupSaveUser,DefaultCampaign:DefaultCampaignSaveUser,TimeZoneId:TimeZoneId,countryCode:countryCode,groups:groups,AllegroIntegration:vPeer};
		
		icApi.SaveUser(request, function(status, /*response*/) { 
			document.forms.formUsers.elements.resultSaveUser.value = status;
		});
		return false;
	});	
	
	$("form[name='formUsers']").find("#submitActivateUser").bind("click", function() {				
		
		var userId = document.forms.formUsers.elements.IdActivateUser.value;
		icApi.ActivateUser(userId, function(status, /*response*/) { 
			document.forms.formUsers.elements.resultActivateUser.value = status;
		});
		return false;
	});	
	
	$("form[name='formUsers']").find("#submitDeActivateUser").bind("click", function() {				
		
		var userId = document.forms.formUsers.elements.IdDeActivateUser.value;
		icApi.DeactivateUser(userId, function(status, /*response*/) { 
			document.forms.formUsers.elements.resultDeActivateUser.value = status;
		});
		return false;
	});


	// ================================= USERS STATES DETAIL (ARCHIVE / HISTORY) ===========================================
	/*
{
  "rowsPerPage": 2,
  "lastRowOfPage": "campi6tel2|agente10|2022-01-05 11:26:45.000|state: off to lunch|vcc1@AgentStateLapse:c81ff241-7a67-4bc2-addf-70636afe562b",
  "queryFields": {
     "startDate": "2021-12-15 00:00:00",
     "endDate": "2022-01-03 23:59:59"
   }
}
	*/
	$("#users_reports_execute").bind("click", function() {
		const $users_reports_filter_type = $("#users_reports_filter_type");
		const apiMethodName = $users_reports_filter_type.val();
		if (typeof icApi[apiMethodName] !== "function") {
			window.alert("API Method " + apiMethodName + " does not exist");
			return;
		}

		let request = {};

		if (apiMethodName !== "UsersRealTimeLoggedIn") {
			request.queryFields = {};
			// rango
			request.queryFields.startDate = $("#users_reports_filter_startdate").val();
			request.queryFields.endDate = $("#users_reports_filter_enddate").val();
			// state
			const userState = $("#users_reports_filter_state").val();
			if (userState !== "") {
				request.queryFields.State = userState;
			}
			// campaign
			const campaign = $("#users_reports_filter_campaign").val();
			if (campaign !== "") {
				request.queryFields.Campaign = campaign;
			}
			// agent
			if (apiMethodName === "UsersStatesQueryByAgent") {
				const agent = $("#users_reports_filter_agent").val();
				if (agent !== "") {
					request.queryFields.Agent = agent;
				}
			}
			// paginated
			request.rowsPerPage = parseInt($("#users_reports_rows_per_page").val(), 10);
			let lastRowOfPage  = $("#users_reports_rows_page_number").val();
			if (lastRowOfPage) {
				request.lastRowOfPage = lastRowOfPage;
			}
		}

		const return_info_type = $("#users_reports_return_info_type").val();
		if (return_info_type !== "default") {
			request.returnInfo = {};
			request.returnInfo.type = return_info_type;
		}

		const $users_reports_filter = $("#users_reports_filter");
		const $users_reports_execute_result = $("#users_reports_execute_result");

		$users_reports_filter.text(JSON.stringify(request));

		$users_reports_execute_result.text("...");
		icApi[apiMethodName](request, function(status, response) {
			$users_reports_execute_result.text(JSON.stringify(response));
			if (response.status) {
				let nextRowPage = response.content.last_handle;
				$("#users_reports_rows_page_number").val(nextRowPage);
			}
		});

		return false;
	});

	$("#users_reports_filter_type").bind("change", function() {
		let apiMethodName = $(this).val();
		if (apiMethodName === "UsersRealTimeLoggedIn") {
			$("#users_reports_filter_parameters").hide();
			// paginated
			$("#users_reports_paginated").hide();
		}
		else {
			$("#users_reports_filter_parameters").show();
			if (apiMethodName === "UsersStatesQueryByCampaign") {
				$("#users_reports_filter_agent_section").hide();
			}
			else {
				$("#users_reports_filter_agent_section").show();
			}
			// paginated
			$("#users_reports_paginated").show();
		}
	});


	// ================================= Repository ===========================================
	$("form[name='formRepo']").find("#submitAddFileToRepository").click(function() {
		$("#fileAddFile")[0].click();
		return false;
	});
	
	$("#fileAddFile").change(function(event) {
		var file = event.target.files[0];
		if ( !file ) {
		return;
		}
		var fileId = document.forms.formRepo.elements.idFile.value;
		var section = document.forms.formRepo.elements.section.value;
		var request = {id:fileId, section:section, file:file};
		icApi.AddFileToRepository(request, function(status, data) { 
			document.forms.formRepo.elements.resultAddFileToRepository.value = status;
			console.log("Status: " + status + " Data: " + data); 
		});
		return false;
	});

	
	$("form[name='formRepo']").find("#submitAddContent").bind("click", function() {				
		
		var fileId = document.forms.formRepo.elements.idAddContent.value;
		var section = document.forms.formRepo.elements.sectionAddContent.value;
		var name = document.forms.formRepo.elements.nameAddContent.value;
		var content = document.forms.formRepo.elements.contentAddContent.value;
		var contentType = document.forms.formRepo.elements.contentTypeAddContent.value;
		var formatType = document.forms.formRepo.elements.formatTypeAddContent.value;
		var request = {id:fileId, section:section, name:name, content:content, contentType:contentType, format:formatType};
		icApi.AddContentToRepository(request, function(status, /*response*/) { 
			document.forms.formRepo.elements.resultAddContent.value = status;
		});
		return false;
	});	
	
	$("form[name='formRepo']").find("#submitGetFileToRepository").bind("click", function() {				
		
		var fileId = document.forms.formRepo.elements.idGetFile.value;
		var section = document.forms.formRepo.elements.sectionGetFile.value;
		//var file = "";
		var request = {id:fileId, section:section};
		icApi.GetFileFromRepository(request, function(status, data) { 
			document.forms.formRepo.elements.resultGetFileToRepository.value = status;
			console.log(data); 
		});
		return false;
	});	
	
	$("form[name='formRepo']").find("#submitDeleteFile").bind("click", function() {				
		
		var fileId = document.forms.formRepo.elements.idDeleteFile.value;
		var section = document.forms.formRepo.elements.sectionDeleteFile.value;
		var request = {id:fileId, section:section};
		icApi.DeleteFileFromRepository(request, function(status, /*response*/) { 
			document.forms.formRepo.elements.resultDeleteFile.value = status;
		});
		return false;
	});	
	
	$("form[name='formRepo']").find("#submitDeleteFiles").bind("click", function() {				
		
		var files = [{id:"file1",section:-1},{id:"file2",section:-1}];
		var request = {files:files};
		icApi.DeleteFilesFromRepository(request, function(status, /*response*/) { 
			document.forms.formRepo.elements.resultDeleteFiles.value = status;
		});
		return false;
	});	
	
	// ================================= INTERACTIONS ===========================================
	$("form[name='formInteractions']").find("#submitGetInteraction").bind("click", function() {
		
		var interactionID = document.forms.formInteractions.elements.GetInteraction_interactionId.value;
		icApi.GetInteraction(interactionID, function(status, response) {
			document.forms.formInteractions.elements.GetInteraction_result.value = JSON.stringify(response);
		});
		return false;
	});	
	$("form[name='formInteractions']").find("#submitGetInteractionMediaList").bind("click", function() {				
		
		var interactionID = document.forms.formInteractions.elements.GetInteractionMediaList_id.value;
		icApi.GetInteractionMediaList(interactionID, function(status, /*response*/) { 
			document.forms.formInteractions.elements.GetInteractionMediaList_result.value = status;
		});
		return false;
	});	
	$("form[name='formInteractions']").find("#submitGetInteractionMediaFile").bind("click", function() {				
		var interId = document.forms.formInteractions.elements.GetInteractionMediaFile_Interid.value;
		var fileId = document.forms.formInteractions.elements.GetInteractionMediaFile_id.value;
		var section = document.forms.formInteractions.elements.GetInteractionMediaList_section.value;
		var part = document.forms.formInteractions.elements.GetInteractionMediaList_part.value;
		var request = {interaction:interId, id:fileId, section:section, part:part};
		icApi.GetInteractionMediaFile(request, function(status, /*response*/) { 
			document.forms.formInteractions.elements.GetInteractionMediaFile_result.value = status;
		});
		return false;
	});

	// ================================= ACTIVE (RUNTIME) INTERACTIONS DETAIL ===========================================
	/*
{
  "rowsPerPage": 2,
  "lastRowOfPage": "campi6tel2|agente10|2022-01-05 11:26:45.000|state: off to lunch|vcc1@AgentStateLapse:c81ff241-7a67-4bc2-addf-70636afe562b",
  "queryFields": {
     "startDate": "2021-12-15 00:00:00",
     "endDate": "2022-01-03 23:59:59"
   }
}
	*/
		$("#interactions_live_execute").bind("click", function() {
			const $interactions_live_filter_type = $("#interactions_live_filter_type");
			const apiMethodName = $interactions_live_filter_type.val();
			if (typeof icApi[apiMethodName] !== "function") {
				window.alert("API Method " + apiMethodName + " does not exist");
				return;
			}

			let request = {
				rowsPerPage: parseInt($("#interactions_live_rows_per_page").val(), 10),
				queryFields: {
					startDate: $("#interactions_live_filter_startdate").val(),
					endDate: $("#interactions_live_filter_enddate").val()
				}
			};

			let lastRowOfPage  = $("#interactions_live_rows_page_number").val();
			if (lastRowOfPage) {
				request.lastRowOfPage = lastRowOfPage;
			}

			const interactionState = $("#interactions_live_filter_state").val();
			if (interactionState !== "") {
				request.queryFields.InteractionState = interactionState;
			}

			const campaign = $("#interactions_live_filter_campaign").val();
			if (campaign !== "") {
				request.queryFields.Campaign = campaign;
			}
			const return_info_type = $("#interactions_live_return_info_type").val();
			if (return_info_type !== "") {
				request.returnInfo = {};
				request.returnInfo.type = return_info_type;
			}

			const $interactions_live_filter = $("#interactions_live_filter");
			const $interactions_live_execute_result = $("#interactions_live_execute_result");

			$interactions_live_filter.text(JSON.stringify(request));

			$interactions_live_execute_result.text("...");
			icApi[apiMethodName](request, function(status, response) {
				$interactions_live_execute_result.text(JSON.stringify(response));
				if (response.status) {
					let nextRowPage = parseInt(response.content.last_handle, 10);
					$("#interactions_live_rows_page_number").val(nextRowPage);
				}
			});

			return false;
		});

	// ================================= ARCHIVE (HISTORY) INTERACTIONS DETAIL ===========================================
	/*
{
  "rowsPerPage": 2,
  "lastRowOfPage": "campi6tel2|agente10|2022-01-05 11:26:45.000|state: off to lunch|vcc1@AgentStateLapse:c81ff241-7a67-4bc2-addf-70636afe562b",
  "queryFields": {
     "startDate": "2021-12-15 00:00:00",
     "endDate": "2022-01-03 23:59:59"
   }
}
	*/
	$("#interactions_archive_execute").bind("click", function() {
		const $interactions_archive_filter_type = $("#interactions_archive_filter_type");
		const apiMethodName = $interactions_archive_filter_type.val();
		if (typeof icApi[apiMethodName] !== "function") {
			window.alert("API Method " + apiMethodName + " does not exist");
			return;
		}

		let request = {
			rowsPerPage: parseInt($("#interactions_archive_rows_per_page").val(), 10),
			queryFields: {
				startDate: $("#interactions_archive_filter_startdate").val(),
				endDate: $("#interactions_archive_filter_enddate").val()
			}
		};

		let lastRowOfPage  = $("#interactions_archive_rows_page_number").val();
		if (lastRowOfPage) {
			request.lastRowOfPage = JSON.parse(lastRowOfPage);
		}

		const interactionInitiative = $("#interactions_archive_filter_initiative").val();
		if (interactionInitiative !== "") {
			request.queryFields.Initiative = interactionInitiative;
		}

		let methodType = apiMethodName.substr(apiMethodName.length - 8).toLowerCase(); // => "campaign"
		if (methodType === "campaign") {
			const campaign = $("#interactions_archive_filter_campaign").val();
			if (campaign !== "") {
				request.queryFields.Campaign = campaign;
			}
		}
		else {
			const agent = $("#interactions_archive_filter_agent").val();
			if (agent !== "") {
				request.queryFields.Agent = agent;
			}
		}

		const return_info_type = $("#interactions_archive_return_info_type").val();
		if (return_info_type !== "") {
			request.returnInfo = {};
			request.returnInfo.type = return_info_type;
		}

		const $interactions_archive_filter = $("#interactions_archive_filter");
		const $interactions_archive_execute_result = $("#interactions_archive_execute_result");

		$interactions_archive_filter.text(JSON.stringify(request));

		$interactions_archive_execute_result.text("...");
		icApi[apiMethodName](request, function(status, response) {
			$interactions_archive_execute_result.text(JSON.stringify(response));
			if (response.status) {
				let nextRowPage = JSON.stringify(response.content.last_handle);
				$("#interactions_archive_rows_page_number").val(nextRowPage);
			}
		});

		return false;
	});

	$("#interactions_archive_filter_type").bind("change", function() {
		let apiMethodName = $(this).val();
		let type = apiMethodName.substr(apiMethodName.length - 8).toLowerCase(); // => "campaign"
		if (type === "campaign") {
			$("#interactions_archive_filter_campaign_section").show();
			$("#interactions_archive_filter_agent_section").hide();
		}
		else {
			$("#interactions_archive_filter_campaign_section").hide();
			$("#interactions_archive_filter_agent_section").show();
		}
	});

	// ================================= INTERACTIONS DETAIL ===========================================
	/*{

		Request de ejemplo:
        {"last":"","rows":20,"query":{"condition": "AND", "rules": [{"id": "start_date", "value": "2022-03-28 08:42:09", "operator": "equal"}, {"id": "campaign", "value": ["test"], "operator": "equal"}]},"paginating":true,"exact":false,"output":"interactions"}
	} */


	$("#load_interactions_data_execute").bind("click", function() {
		if (!icApi) {
			window.alert("DEBE INICIAR SESION CON EL USUARIO DEL API.");
			return;
		}
		const $load_interactions_data_execute_result = $("#load_interactions_data_execute_result");
		const rows  = parseInt($("#load_interactions_data_rows_per_page").val(), 10);
		const $from  = $("#load_interactions_data_from_page");

		const type = $("#load_interactions_data_filter_type").val();
		const type_operator = $("#load_interactions_data_filter_type_operator").val();

		const startDate = $("#load_interactions_data_filter_startdate").val();
		const startDate_operator = $("#load_interactions_data_filter_startdate_operator").val();
		const endDate = $("#load_interactions_data_filter_enddate").val();

		const state = $("#load_interactions_data_filter_state").val();
		const state_operator = $("#load_interactions_data_filter_state_operator").val();

		const date_state_from = $("#load_interactions_data_filter_startdate_state").val();
		const date_state_operator = $("#load_interactions_data_filter_startdate_state_operator").val();
		const date_state_to = $("#load_interactions_data_filter_enddate_state").val();

		const date_last_event_from = $("#load_interactions_data_filter_startdate_lastevent").val();
		const date_last_event_operator = $("#load_interactions_data_filter_startdate_lastevent_operator").val();
		const date_last_event_to = $("#load_interactions_data_filter_enddate_lastevent").val();

		const campaign = $("#load_interactions_data_filter_campaign").val();
		const campaign_operator = $("#load_interactions_data_filter_campaign_operator").val();

		const agent = $("#load_interactions_data_filter_agent").val();
		const agent_operator = $("#load_interactions_data_filter_agent_operator").val();

		const initiative = $("#load_interactions_data_filter_initiative").val();
		const initiative_operator = $("#load_interactions_data_filter_initiative_operator").val();

		const account = $("#load_interactions_data_filter_account").val();
		const account_operator = $("#load_interactions_data_filter_account_operator").val();

		const contact_id = $("#load_interactions_data_filter_contact").val();
		const contact_id_operator = $("#load_interactions_data_filter_contact_operator").val();

		const contact_name = $("#load_interactions_data_filter_contact_name").val();
		const contact_name_operator = $("#load_interactions_data_filter_contact_name_operator").val();

		const contact_address = $("#load_interactions_data_filter_contact_address").val();
		const contact_addres_operator = $("#load_interactions_data_filter_contact_address_operator").val();

		const ticket = $("#load_interactions_data_filter_ticket").val();
		const ticket_operator = $("#load_interactions_data_filter_ticket_operator").val();

		const att_level = $("#load_interactions_data_filter_att_level").val();
		const att_level_operator = $("#load_interactions_data_filter_att_level_operator").val();

		const text = $("#load_interactions_data_filter_text").val();
		const text_operator = $("#load_interactions_data_filter_text_operator").val();

		const disposition_tree_code = $("#load_interactions_data_filter_disposition_tree_code").val();
		const disposition_tree_code_operator = $("#load_interactions_data_filter_disposition_tree_code_operator").val();

		const disposition_code = $("#load_interactions_data_filter_disposition_code").val();
		const disposition_code_operator = $("#load_interactions_data_filter_disposition_code_operator").val();

		const min_duration = $("#load_interactions_data_filter_min_duration").val();
		const duration_operator = $("#load_interactions_data_filter_duration_operator").val();
		const max_duration = $("#load_interactions_data_filter_max_duration").val();

		const interaction_id = $("#load_interactions_data_filter_interactionId").val();
		const interaction_id_operator = $("#load_interactions_data_filter_interactionId_operator").val();
		
		
		let last = $from.val() || "0";
		let request = {
			rows : rows,
			query : {
				condition: "AND",
				rules: []
			},
			last : last,
		};

		if(type){
			request.query.rules.push({id:"type", operator:type_operator, value:type});
		}

		if(startDate){
			request.query.rules.push({id:"start_date", operator:startDate_operator, value:startDate, value_to:startDate_operator === "between" ? endDate : undefined});
		}

		if(state !==""){
			request.query.rules.push({id:"state", operator:state_operator, value:state});
		}

		if(date_state_from){
			request.query.rules.push({id:"date_state_from", operator:date_state_operator, value:date_state_from, value_to:date_state_operator === "between" ? date_state_to : undefined});
		}

		if(date_last_event_from){
			request.query.rules.push({id:"last_event_timestamp", operator:date_last_event_operator, value:date_last_event_from, value_to:date_last_event_operator === "between" ? date_last_event_to : undefined});
		}

		if(campaign && campaign !==""){
			var rule = {id:"campaign", operator:campaign_operator};
			if(['equal', 'not_equal'].indexOf(campaign_operator) !== -1) {
				let jsonCampaign = JSON.parse(campaign);
				rule.value = jsonCampaign;
			}
			else {
				rule.value = campaign;
			}
			request.query.rules.push(rule);
		}

		if(agent && agent !==""){
			var rule = {id:"agent", operator:agent_operator};
			if(['equal', 'not_equal'].indexOf(agent_operator) !== -1) {
				let jsonAgent = JSON.parse(agent);
				rule.value = jsonAgent;
			}
			else {
				rule.value = agent;
			}
			request.query.rules.push(rule);
		}
		
		if(initiative && initiative !==""){
			request.query.rules.push({id:"initiative", operator:initiative_operator, value:initiative});
		}

		if(account && account !==""){
			var rule = {id:"account", operator:account_operator};
			if(['equal', 'not_equal'].indexOf(account_operator) !== -1) {
				let jsonAccount = JSON.parse(account);
				rule.value = jsonAccount;
			}
			else {
				rule.value = account;
			}
			request.query.rules.push(rule);
		}

		if(contact_id && contact_id !==""){
			request.query.rules.push({id:"contact", operator:contact_id_operator, value:contact_id});
		}

		if(contact_name && contact_name !==""){
			request.query.rules.push({id:"contact_name", operator:contact_name_operator, value:contact_name});
		}

		if(contact_address && contact_address !==""){
			request.query.rules.push({id:"contact_address", operator:contact_addres_operator, value:contact_address});
		}

		if(ticket && ticket !==""){
			var rule = {id:"ticket", operator:ticket_operator};
			if(['equal', 'not_equal'].indexOf(ticket_operator) !== -1) {
				let jsonTicket = JSON.parse(ticket);
				rule.value = jsonTicket;
			}
			else {
				rule.value = ticket;
			}
			request.query.rules.push(rule);
		}

		if(att_level && att_level !==""){
			var rule = {id:"attention_level", operator:att_level_operator};
			if(['equal', 'not_equal'].indexOf(att_level_operator) !== -1) {
				let jsonAttLevel = JSON.parse(att_level);
				rule.value = jsonAttLevel;
			}
			else {
				rule.value = att_level;
			}
			request.query.rules.push(rule);
		}

		if(text && text !==""){
			request.query.rules.push({id:"content", operator:text_operator, value:text});
		}

		if(disposition_code && disposition_code !==""){
			var rule = {id:"disposition_code", operator:disposition_code_operator};
			if(['equal', 'not_equal'].indexOf(disposition_code_operator) !== -1) {
				let jsonDispositionCode = JSON.parse(disposition_code);
				rule.value = jsonDispositionCode;
			}
			else {
				rule.value = disposition_code;
			}
			request.query.rules.push(rule);
		}

		if(disposition_tree_code && disposition_tree_code !==""){
			var rule = {id:"disposition_tree_code", operator:disposition_tree_code_operator, value: disposition_tree_code};
			request.query.rules.push(rule);
		}

		if(min_duration !==""){
			request.query.rules.push({id:"attention_time", operator:duration_operator, value:parseInt(min_duration,10), value_to:duration_operator === "between" ? parseInt(max_duration,10) : undefined});
		}

		if(interaction_id && interaction_id !==""){
			var rule = {id:"id", operator:interaction_id_operator};
			let jsonInteractionId = JSON.parse(interaction_id);
			rule.value = jsonInteractionId;
			request.query.rules.push(rule);
		}

		var businessDataRule = {id:"businessdata", operator:""}
		let i = 0;
		var fillBusinessDataFields = function() {
			i++;
			let dom_id = "#load_interactions_data_filter_businessdata_field_type_" + i;
			const $field_type = $(dom_id);
			let field_type =  $field_type.val();

			dom_id = "#load_interactions_data_filter_businessdata_field_name_" + i;
			const $field_name = $(dom_id);
			if ($field_name.length === 0) {
				return;
			}
			dom_id = "#load_interactions_data_filter_businessdata_field_value_" + i;
			const $field_value = $(dom_id);
			if ($field_value.length === 0) {
				return;
			}

			let field_name = $field_name.val().trim();
			if (field_name.length === 0) {
				return;
			}
			let field_value = $field_value.val().trim();

			let queryField = {
				type : field_type,
				name : field_name,
				value: field_value
			};

			dom_id = "#load_interactions_data_filter_businessdata_field_operator_" + i;
			const $operator = $(dom_id);
			if ($operator.length > 0) {
				queryField.operator = $operator.val();
				if (queryField.operator === "between") {
					dom_id = "#load_interactions_data_filter_businessdata_field_value_to_" + i;
					const $field_value_to = $(dom_id);
					queryField.value_to = $field_value_to.val();
				}
			}

			businessDataRule.value = businessDataRule.value || [];
			businessDataRule.value.push(queryField);
		};

		// Business data Name-Value1
		fillBusinessDataFields();
		// Business data Name-Value2
		fillBusinessDataFields();

		if(businessDataRule.value) {
			request.query.rules.push(businessDataRule);
		}

		const $load_interactions_data_filter = $("#load_interactions_data_filter");
		$load_interactions_data_filter.text(JSON.stringify(request));

		icApi.loadInteractionsData(request, function(status, response) {

			$from.val(response.content && response.content.last || 0);
			$load_interactions_data_execute_result.text(JSON.stringify(response));
		});
		return false;
	});

	$("#load_interactions_data_filter_type_operator").bind("change", function() {
		const related_between = $(this).attr("related_between");
		const $related_between = $("#" + related_between);
		const operator = $(this).val();;
		$related_between.empty();
		var allowedTypes = [];

		if (operator === "equal") {
			allowedTypes.push({text:"ALL",value:""});
		}
		allowedTypes.push({text:"Mail",value:"MAIL"});
		allowedTypes.push({text:"Call",value:"CALL"});
		allowedTypes.push({text:"Chat",value:"CHAT"});
		allowedTypes.push({text:"Facebook",value:"FACEBOOK"});
		allowedTypes.push({text:"Instagram",value:"INSTAGRAM"});
		allowedTypes.push({text:"Youtube",value:"YOUTUBE"});
		allowedTypes.push({text:"AppStore",value:"APPSTORE"});
		allowedTypes.push({text:"GooglePlay",value:"GOOGLEPLAY"});
		allowedTypes.push({text:"Rcs",value:"RCS"});
		allowedTypes.push({text:"Im",value:"IM"});
		allowedTypes.push({text:"Sms",value:"SMS"});
		allowedTypes.push({text:"Whatsapp",value:"WHATSAPP"});
		allowedTypes.push({text:"Twitter",value:"TWITTER"});
		allowedTypes.push({text:"Webcontact",value:"WEBCONTACT"});
		allowedTypes.push({text:"Voicemail",value:"VOICEMAIL"});
		for (var i = 0; i < allowedTypes.length; i++) {
			$related_between.append($('<option>', { 
		        value: allowedTypes[i].value,
		        text : allowedTypes[i].text
		    }));
		}
	});

	$("#load_interactions_data_filter_state_operator").bind("change", function() {
		const related_between = $(this).attr("related_between");
		const $related_between = $("#" + related_between);
		const operator = $(this).val();;
		$related_between.empty();
		var allowedStates = [];

		if (operator === "equal") {
			allowedStates.push({text:"ALL",value:""});
		}
		allowedStates.push({text:"ABANDONED",value:"ABANDONED"});
		allowedStates.push({text:"FINISHED",value:"FINISHED"});
		allowedStates.push({text:"QUEUED",value:"QUEUED"});
		allowedStates.push({text:"LOCKED",value:"LOCKED"});
		allowedStates.push({text:"TAKEN",value:"TAKEN"});
		allowedStates.push({text:"TRANSFER QUEUED",value:"TRANSFER QUEUED"});
		allowedStates.push({text:"WAITING",value:"WAITING"});
		allowedStates.push({text:"WRAPUP",value:"WRAPUP"});
		for (var i = 0; i < allowedStates.length; i++) {
			$related_between.append($('<option>', { 
		        value: allowedStates[i].value,
		        text : allowedStates[i].text
		    }));
		}
	});

	$("#load_interactions_data_filter_initiative_operator").bind("change", function() {
		const related_between = $(this).attr("related_between");
		const $related_between = $("#" + related_between);
		const operator = $(this).val();;
		$related_between.empty();
		var allowedInitiatives = [];

		if (operator === "equal") {
			allowedInitiatives.push({text:"ALL",value:""});
		}
		allowedInitiatives.push({text:"Inbound",value:"INBOUND"});
		allowedInitiatives.push({text:"Outbound",value:"OUTBOUND"});
		for (var i = 0; i < allowedInitiatives.length; i++) {
			$related_between.append($('<option>', { 
		        value: allowedInitiatives[i].value,
		        text : allowedInitiatives[i].text
		    }));
		}
	});

	$("#load_interactions_data_filter_businessdata_field_type_1, #load_interactions_data_filter_businessdata_field_type_2").bind("change", function() {
		const related_between = $(this).attr("related_between");
		const $related_between = $("#" + related_between);
		const fieldType = $(this).val();;
		$related_between.empty();
		var allowedFieldOperators = [];
		allowedFieldOperators.push({value:"equal",text:"Igual"});
		allowedFieldOperators.push({value:"not_equal",text:"Distinto"});
		if(fieldType === "text") {
			allowedFieldOperators.push({value:"contains",text:"Contiene"});
			allowedFieldOperators.push({value:"not_contains",text:"No contiene"});
		}
		if(fieldType === "date" || fieldType === "numeric") {
			allowedFieldOperators.push({value:"less",text:"Menor"});
			allowedFieldOperators.push({value:"less_or_equal",text:"Menor o Igual"});
			allowedFieldOperators.push({value:"greater",text:"Mayor"});
			allowedFieldOperators.push({value:"greater_or_equal",text:"Mayor o Igual"});
			allowedFieldOperators.push({value:"between",text:"Entre 2 valores"});
		}
		for (var i = 0; i < allowedFieldOperators.length; i++) {
			$related_between.append($('<option>', { 
		        value: allowedFieldOperators[i].value,
		        text : allowedFieldOperators[i].text
		    }));
		}
	});

	$("#load_interactions_data_filter_startdate_operator, \
		#load_interactions_data_filter_startdate_state_operator, \
		#load_interactions_data_filter_startdate_lastevent_operator, \
		#load_interactions_data_filter_businessdata_field_operator_1, \
		#load_interactions_data_filter_businessdata_field_operator_2, \
		#load_interactions_data_filter_duration_operator").bind("change", function() {
		const related_between = $(this).attr("related_between");
		const $related_between = $("#" + related_between);
		const operator = $(this).val();
		if (operator === "between") {
			$related_between.show();
		}
		else {
			$related_between.hide();
		}
	});

	// ================================= WEBCONTACT ===========================================
	$("form[name='formStartInteraction']").find("#submitWebContact").bind("click", function() {				
		
		var vCampaign = document.forms.formStartInteraction.elements.StartWebContact_Campaign.value; 
		var vAccount = document.forms.formStartInteraction.elements.StartWebContact_Account.value; 
		var vContactName = document.forms.formStartInteraction.elements.StartWebContact_ContactName.value; 
		
		var vContactAddress = [{type:"MAIL",address:"clobo@inconcert.es"}];
		
		var vAgentData = [{name:"CampoAgente",value:"Valor que se muestra en el agente",displayName:"Display"}];
		var vContact ={name:vContactName,addresses:vContactAddress};
		var request = {campaign:vCampaign, account_name:vAccount, contact:vContact,agentData:vAgentData};
		icApi.StartWebcontact(request, function(status, /*response*/) { 
			document.forms.formStartInteraction.elements.StartWebContact_result.value = status;
		});
		return false;
	});
	
	// ================================= MAIL ===========================================
	var vStartMailAttachments = [];
	$("form[name='formStartInteraction']").find("#cmdAddMailAttach").click(function() {
		$("#StartMail_AddAttach")[0].click() ;
		return false;
	});
	
	$("#StartMail_AddAttach").change(function(event) {
		for (var i = 0; i < event.target.files.length; i++) {
			var table = document.getElementById("startMailFilesTable");
			var row = table.insertRow();
			var cellFileNumber = row.insertCell(0);
			var cellFileName = row.insertCell(1);
			cellFileNumber.innerHTML = vStartMailAttachments.length + 1;
			cellFileName.innerHTML = event.target.files[i].name;
			cellFileNumber.style = "border: 1px solid black;";
			cellFileName.style = "border: 1px solid black;";
			vStartMailAttachments.push(event.target.files[i]);
		}	
		
		return false;
	});
	
	$("form[name='formStartInteraction']").find("#submitMail").bind("click", function() {				
		
		var vCampaign = document.forms.formStartInteraction.elements.StartMail_Campaign.value; 
		var vAccount = document.forms.formStartInteraction.elements.StartMail_Account.value; 
		var vFromEMail = document.forms.formStartInteraction.elements.StartMail_FromEmail.value || undefined; 
		var vFromName = document.forms.formStartInteraction.elements.StartMail_FromName.value || undefined; 
		var vCC = document.forms.formStartInteraction.elements.StartMail_CC.value || undefined; 	
		if(vCC !== undefined)
		{
			vCC = vCC.split(";");	
		}
		var vSubject = document.forms.formStartInteraction.elements.StartMail_Subject.value || undefined; 
		var vBody = document.forms.formStartInteraction.elements.StartMail_Body.value || undefined; 
		var vHead ={fromEMail:vFromEMail, fromName:vFromName, cc:vCC, subject:vSubject};
		var request = {campaign:vCampaign, account_name:vAccount, head:vHead, body:vBody, attachments:vStartMailAttachments};
		icApi.StartMail(request, function(status, /*response*/) { 
			document.forms.formStartInteraction.elements.StartMail_result.value = status;
		});
		return false;
	});	
	
	// ================================= WHATSAPP ===========================================
	var vStartWhatsappAttachments = [];
	$("form[name='formStartInteraction']").find("#cmdAddWhatsappAttach").click(function() {
		$("#StartWhatsapp_AddAttach")[0].click();
		return false;
	});
	
	$("#StartWhatsapp_AddAttach").change(function(event) {
		for (var i = 0; i < event.target.files.length; i++) {
			var table = document.getElementById("startWhatsappFilesTable");
			var row = table.insertRow();
			var cellFileNumber = row.insertCell(0);
			var cellFileName = row.insertCell(1);
			cellFileNumber.innerHTML = vStartWhatsappAttachments.length + 1;
			cellFileName.innerHTML = event.target.files[i].name;
			cellFileNumber.style = "border: 1px solid black;";
			cellFileName.style = "border: 1px solid black;";
			vStartWhatsappAttachments.push(event.target.files[i]);
		}	
		
		return false;
	});
	
	$("form[name='formStartInteraction']").find("#submitWhatsapp").bind("click", function() {
		var vCampaign = document.forms.formStartInteraction.elements.StartWhatsapp_Campaign.value; 
		var vAccount = document.forms.formStartInteraction.elements.StartWhatsapp_Account.value; 
		var vContactName = document.forms.formStartInteraction.elements.StartWhatsapp_ContactName.value || undefined; 
		var vAddress = document.forms.formStartInteraction.elements.StartWhatsapp_Address.value || undefined; 
		var vText = document.forms.formStartInteraction.elements.StartWhatsapp_Text.value || undefined; 
		var request = {campaign:vCampaign, account_name:vAccount, name:vContactName, address:vAddress, text:vText, attachments:vStartWhatsappAttachments};
		icApi.StartWhatsapp(request, function(status, /*response*/) { 
			document.forms.formStartInteraction.elements.StartWhatsapp_result.value = status;
		});
		return false;
	});


	//Get Channels and States & Available Agents/Channels slots
	$("#submitGetStates").bind("click", function() {
		const $result = $("#get_states_result");
		icApi.GetStates(function(status, response) { 
			$result.text(JSON.stringify(response));
		});
		return false;
	});

	$("#submitGetChannels").bind("click", function() {
		const $result = $("#get_channels_result");

		icApi.GetChannels(function(status, response) { 
			$result.text(JSON.stringify(response));
		});
		return false;
	});

	$("#submitGetAvblAgents").bind("click", function() {
		const $result       = $("#get_agents_result");
		const avblVcc       = document.forms.formChannelStates.elements.idAvblAgentVcc.value;
		const avblCampaign  = document.forms.formChannelStates.elements.idAvblAgentCampaign.value;
		const avblChannel   = document.forms.formChannelStates.elements.idAvblAgentChannel.value;
		const avblattLevel  = document.forms.formChannelStates.elements.idAvblAttLevel.value;
		let request         = { vcc: avblVcc, campaign: avblCampaign, channel: avblChannel, idAttLevel: avblattLevel }

		icApi.GetAvailableAgents(request, function(status, response) { 
			$result.text(JSON.stringify(response));
		});
		return false;
	});


	//Get Composite Interaction
	$("#submitGetCompositeInteraction").bind("click", function() {
		const $result = $("#composite_interaction_result");
		const id = $("#composite_interaction_id").val();
		icApi.GetCompositeInteraction(id, function(status, response) { 
			$result.text(JSON.stringify(response));
		});
		return false;
	});


	$("#submitGetExportInfoUsers").bind("click", function() {
		const $result = $("#get_export_info_users_result");

		icApi.GetUsersExportInfo(function(status, response) { 
			$result.text(JSON.stringify(response))
		});
		return false;
	});

	$("#submitGetExportInfoGroups").bind("click", function() {
		const $result = $("#get_export_info_groups_result");

		icApi.GetGroupsExportInfo(function(status, response) { 
			$result.text(JSON.stringify(response))
		});
		return false;
	});


	$("#submitGetExportInfoUsers").bind("click", function() {
		const $result = $("#get_export_info_users_result");

		icApi.GetUsersExportInfo(function(status, response) { 
			$result.text(JSON.stringify(response))
		});
		return false;
	});

	$("#submitGetExportInfoGroups").bind("click", function() {
		const $result = $("#get_export_info_groups_result");

		icApi.GetGroupsExportInfo(function(status, response) { 
			$result.text(JSON.stringify(response))
		});
		return false;
	});

	// ================================= OUTBOUND ENGINE PROCESS ===========================================
	$("form[name='formOutboundEngineProcess']").find("#submitGetOutboundProcess").bind("click", function() {				
		
		var vProcessId = document.forms.formOutboundEngineProcess.elements.GetOutboundProcess_process.value; 
		icApi.GetOutboundProcess(vProcessId, function(_status, response) { 
			document.forms.formOutboundEngineProcess.elements.GetOutboundProcess_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineProcess']").find("#submitStartOutboundProcess").bind("click", function() {				
		
		var vProcessId = document.forms.formOutboundEngineProcess.elements.StartOutboundProcess_process.value; 
		icApi.StartOutboundProcess(vProcessId, function(_status, response) { 
			document.forms.formOutboundEngineProcess.elements.StartOutboundProcess_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineProcess']").find("#submitStopOutboundProcess").bind("click", function() {				
		
		var vProcessId = document.forms.formOutboundEngineProcess.elements.StopOutboundProcess_process.value; 
		icApi.StopOutboundProcess(vProcessId, function(_status, response) { 
			document.forms.formOutboundEngineProcess.elements.StopOutboundProcess_result.value = JSON.stringify(response);
		});
		return false;
	});

	// ================================= OUTBOUND ENGINE BATCH ===========================================
	$("form[name='formOutboundEngineBatch']").find("#submitGetBatchActionStatus").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.GetBatchActionStatus_process.value; 
		var actionId = document.forms.formOutboundEngineBatch.elements.GetBatchActionStatus_actionId.value;
		icApi.GetBatchActionStatus({
			processId: processId,
			actionId: actionId
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.GetBatchActionStatus_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitCreateOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_process.value; 
		var batchId = document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_batchId.value; 
		var startDate = document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_startDate.value; 
		var endDate = document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_endDate.value; 
		var batchPriority = document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_batchPriority.value; 
		var priority = document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_priority.value; 
		var percentage = document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_percentage.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_conditions.value; 
		icApi.CreateOutboundBatch({
			processId: processId,
			configuration: {
				name: batchId,
				startDate: startDate,
				endDate: endDate,
				batchPriority: parseFloat(batchPriority || '0') || null,
				priority: parseFloat(priority || '0') || null,
				percentage: parseFloat(percentage || '0') || 0,
			},
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.CreateOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitUpdateOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.UpdateOutboundBatch_process.value; 
		var batchId = document.forms.formOutboundEngineBatch.elements.UpdateOutboundBatch_batchId.value; 
		var startDate = document.forms.formOutboundEngineBatch.elements.UpdateOutboundBatch_startDate.value; 
		var endDate = document.forms.formOutboundEngineBatch.elements.UpdateOutboundBatch_endDate.value; 
		var batchPriority = document.forms.formOutboundEngineBatch.elements.UpdateOutboundBatch_batchPriority.value; 
		var priority = document.forms.formOutboundEngineBatch.elements.UpdateOutboundBatch_priority.value; 
		var percentage = document.forms.formOutboundEngineBatch.elements.UpdateOutboundBatch_percentage.value; 
		icApi.UpdateOutboundBatch({
			processId: processId,
			batchId: batchId,
			configuration: {
				startDate: startDate,
				endDate: endDate,
				batchPriority: parseFloat(batchPriority || '0') || null,
				basePriority: parseFloat(priority || '0') || null,
				percentage: parseFloat(percentage || '0') || 0,
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.UpdateOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitDestroyOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.DestroyOutboundBatch_process.value; 
		var batchId = document.forms.formOutboundEngineBatch.elements.DestroyOutboundBatch_batchId.value; 
		icApi.DestroyOutboundBatch({
			processId: processId,
			batchId: batchId,
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.DestroyOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitAddContactsToOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.AddContactsToOutboundBatch_process.value; 
		var batchId = document.forms.formOutboundEngineBatch.elements.AddContactsToOutboundBatch_batchId.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.AddContactsToOutboundBatch_conditions.value; 
		icApi.AddContactsToOutboundBatch({
			processId: processId,
			batchId: batchId,
			configuration: {
			},
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.AddContactsToOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitPauseOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.PauseOutboundBatch_process.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.PauseOutboundBatch_conditions.value; 
		icApi.PauseOutboundContacts({
			processId: processId,
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.PauseOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitResumeOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.ResumeOutboundBatch_process.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.ResumeOutboundBatch_conditions.value; 
		icApi.ResumeOutboundContacts({
			processId: processId,
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.ResumeOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitCancelOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.CancelOutboundBatch_process.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.CancelOutboundBatch_conditions.value; 
		icApi.CancelOutboundContacts({
			processId: processId,
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.CancelOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitFinishOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.FinishOutboundBatch_process.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.FinishOutboundBatch_conditions.value; 
		icApi.FinishOutboundContacts({
			processId: processId,
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.FinishOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitRemoveOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.RemoveOutboundBatch_process.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.RemoveOutboundBatch_conditions.value; 
		icApi.FinishOutboundContacts({
			processId: processId,
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.RemoveOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitRemoveOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.RemoveOutboundBatch_process.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.RemoveOutboundBatch_conditions.value; 
		icApi.RemoveOutboundContacts({
			processId: processId,
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.RemoveOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitRecycleOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.RecycleOutboundBatch_process.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.RecycleOutboundBatch_conditions.value; 
		icApi.RecycleOutboundContacts({
			processId: processId,
			configuration: {
				restartRetries: true
			},
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.RecycleOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitScheduleOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.ScheduleOutboundBatch_process.value; 
		var scheduleDate = document.forms.formOutboundEngineBatch.elements.ScheduleOutboundBatch_scheduleDate.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.ScheduleOutboundBatch_conditions.value; 
		icApi.ScheduleOutboundContacts({
			processId: processId,
			configuration: {
				scheduleDate: scheduleDate
			},
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.ScheduleOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitChangePriorityOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.ChangePriorityOutboundBatch_process.value; 
		var priority = document.forms.formOutboundEngineBatch.elements.ChangePriorityOutboundBatch_priority.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.ChangePriorityOutboundBatch_conditions.value; 
		icApi.ChangePriorityOutboundContacts({
			processId: processId,
			priority: parseFloat(priority),
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.ChangePriorityOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitSetEngineTypeOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.SetEngineTypeOutboundBatch_process.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.SetEngineTypeOutboundBatch_conditions.value; 
		icApi.SetEngineTypeOutboundContacts({
			processId: processId,
			configuration: {
				engineType: 'PROGRESSIVE'
			},
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.SetEngineTypeOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitSetAgentOutboundBatch").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.SetAgentOutboundBatch_process.value; 
		var agent = document.forms.formOutboundEngineBatch.elements.SetAgentOutboundBatch_agent.value; 
		var conditions = document.forms.formOutboundEngineBatch.elements.SetAgentOutboundBatch_conditions.value; 
		icApi.SetAgentOutboundContacts({
			processId: processId,
			agent: agent,
			scope: {
				conditions: conditions ? JSON.parse(conditions) : null
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.SetAgentOutboundBatch_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineBatch']").find("#submitGetOutboundEngineActionStatus").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineBatch.elements.GetOutboundEngineActionStatus_process.value; 
		var actionId = document.forms.formOutboundEngineBatch.elements.GetOutboundEngineActionStatus_action.value; 
		icApi.GetOutboundEngineActionStatus({
			processId: processId,
			actionId: actionId
		}, function(_status, response) { 
			document.forms.formOutboundEngineBatch.elements.GetOutboundEngineActionStatus_result.value = JSON.stringify(response);
		});
		return false;
	});

	// ================================= OUTBOUND ENGINE CONTACT ===========================================
	$("form[name='formOutboundEngineContact']").find("#submitGetOutboundContact").bind("click", function() {				
		
		var contactId = document.forms.formOutboundEngineContact.elements.GetOutboundContact_contact.value; 
		icApi.GetOutboundContact(contactId, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.GetOutboundContact_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitGetOutboundContactByName").bind("click", function() {				
		
		var name = document.forms.formOutboundEngineContact.elements.GetOutboundContactByName_name.value; 
		icApi.GetOutboundContactByName(name, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.GetOutboundContactByName_result.value = JSON.stringify(response);
		});
		return false;
	});
	
	$("form[name='formOutboundEngineContact']").find("#submitGetOutboundContactByAddress").bind("click", function() {				
		
		var type = document.forms.formOutboundEngineContact.elements.GetOutboundContactByAddress_type.value; 
		var address = document.forms.formOutboundEngineContact.elements.GetOutboundContactByAddress_address.value; 
		icApi.GetOutboundContactByAddress(type, address, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.GetOutboundContactByAddress_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitListOutboundContacts").bind("click", function() {				
		
		var contactIds = document.forms.formOutboundEngineContact.elements.ListOutboundContacts_contacts.value; 
		icApi.ListOutboundContacts({ 
			contactIds: contactIds.split(','),
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.ListOutboundContacts_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitSearchOutboundContacts").bind("click", function() {				
		
		var conditions = document.forms.formOutboundEngineContact.elements.SearchOutboundContacts_conditions.value; 
		icApi.SearchOutboundContacts({ 
			conditions: conditions ? JSON.parse(conditions) : null,
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.SearchOutboundContacts_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitSummaryOutboundContacts").bind("click", function() {				
		
		var conditions = document.forms.formOutboundEngineContact.elements.SummaryOutboundContacts_conditions.value; 
		icApi.SummaryOutboundContacts({ 
			conditions: conditions ? JSON.parse(conditions) : null,
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.SummaryOutboundContacts_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitStoreOutboundContacts").bind("click", function() {				
		
		var contact = document.forms.formOutboundEngineContact.elements.StoreOutboundContacts_conditions.value; 
		icApi.StoreOutboundContacts({ 
			contacts: [JSON.parse(contact)],
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.StoreOutboundContacts_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitSetContactAddresses").bind("click", function() {				
		
		var contactId = document.forms.formOutboundEngineContact.elements.SetContactAddresses_contact.value; 
		var value = document.forms.formOutboundEngineContact.elements.SetContactAddresses_value.value; 
		icApi.SetContactAddresses({
			contactId,
			addresses: JSON.parse(value)
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.SetContactAddresses_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitSetContactValues").bind("click", function() {				
		
		var contactId = document.forms.formOutboundEngineContact.elements.SetContactValues_contact.value; 
		var value = document.forms.formOutboundEngineContact.elements.SetContactValues_value.value; 
		icApi.SetContactValues({
			contactId,
			text: JSON.parse(value)
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.SetContactValues_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitSetContactSkills").bind("click", function() {				
		
		var contactId = document.forms.formOutboundEngineContact.elements.SetContactSkills_contact.value; 
		var value = document.forms.formOutboundEngineContact.elements.SetContactSkills_value.value; 
		icApi.SetContactSkills({
			contactId,
			skills: JSON.parse(value)
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.SetContactSkills_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitRemoveContactAddress").bind("click", function() {				
		
		var contactId = document.forms.formOutboundEngineContact.elements.RemoveContactAddress_contact.value; 
		var addressType = document.forms.formOutboundEngineContact.elements.RemoveContactAddress_type.value; 
		var address = document.forms.formOutboundEngineContact.elements.RemoveContactAddress_address.value; 
		icApi.RemoveContactAddress({
			contactId,
			addressType,
			address,
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.RemoveContactAddress_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitEnableContactAddress").bind("click", function() {				
		
		var contactId = document.forms.formOutboundEngineContact.elements.EnableContactAddress_contact.value; 
		var addressType = document.forms.formOutboundEngineContact.elements.EnableContactAddress_type.value; 
		var address = document.forms.formOutboundEngineContact.elements.EnableContactAddress_address.value; 
		icApi.EnableContactAddress({
			contactId,
			addressType,
			address,
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.EnableContactAddress_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitDisableContactAddress").bind("click", function() {				
		
		var contactId = document.forms.formOutboundEngineContact.elements.DisableContactAddress_contact.value; 
		var addressType = document.forms.formOutboundEngineContact.elements.DisableContactAddress_type.value; 
		var address = document.forms.formOutboundEngineContact.elements.DisableContactAddress_address.value; 
		icApi.DisableContactAddress({
			contactId,
			addressType,
			address,
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.DisableContactAddress_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitRescheduleOutboundContact").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineContact.elements.RescheduleOutboundContact_process.value; 
		var batchId = document.forms.formOutboundEngineContact.elements.RescheduleOutboundContact_batch.value; 
		var contactId = document.forms.formOutboundEngineContact.elements.RescheduleOutboundContact_contact.value; 
		var scheduleDate = document.forms.formOutboundEngineContact.elements.RescheduleOutboundContact_scheduleDate.value; 
		icApi.RescheduleOutboundContact({ 
			processId: processId,
			batchId: batchId,
			contactId: contactId,
			configuration: {
				scheduleDate: scheduleDate
			}
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.RescheduleOutboundContact_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitGetResultsOutboundContact").bind("click", function() {				
		
		var processId = document.forms.formOutboundEngineContact.elements.GetResultsOutboundContact_process.value; 
		var batchId = document.forms.formOutboundEngineContact.elements.GetResultsOutboundContact_batch.value; 
		var contactId = document.forms.formOutboundEngineContact.elements.GetResultsOutboundContact_contact.value; 
		icApi.GetOutboundContactResults({ 
			processId: processId,
			batchId: batchId,
			contactId: contactId
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.GetResultsOutboundContact_result.value = JSON.stringify(response);
		});
		return false;
	});

	$("form[name='formOutboundEngineContact']").find("#submitValidateAddress").bind("click", function() {				
		
		var type = document.forms.formOutboundEngineContact.elements.ValidateAddress_type.value; 
		var number = document.forms.formOutboundEngineContact.elements.ValidateAddress_number.value; 
		var country = document.forms.formOutboundEngineContact.elements.ValidateAddress_country.value; 
		var area = document.forms.formOutboundEngineContact.elements.ValidateAddress_area.value; 
		icApi.ValidateAddress({ 
			type: type,
			number: number,
			country: country,
			area: area,
		}, function(_status, response) { 
			document.forms.formOutboundEngineContact.elements.ValidateAddress_result.value = JSON.stringify(response);
		});
		return false;
	});

	//--------------------------------------
	return false;

});
