module(..., package.seeall)
local utils = require "shared.apps.utils"
local m_datasource

function GetName()
	return "AgentStates"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function FindAll(vcc, keyspace)
	local states = utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "AgentStates",
		startKey = "",
		endKey = "",
	}
	return utils.FilterEntities(states, function(key, e) return (e.vcc == "system" or e.vcc == vcc) and e.selectable ~= '0' end)
end
