module(..., package.seeall)

--este mapping es discutible y modificable!
function getHTTPCode(result_code)
	local mapping = {
		--agents
		AGENT_NOT_FOUND = 400,
		--mail and im
		CHATSERVER_NOT_AVAILABLE = 500,
		INTERACTION_ALREADY_EXISTS = 400,
		AGENT_UNAVAILABLE = 400,
		FAIL_CREATING_OUTGOING = 500,
		FAIL_TRANSFERRING_TO_AGENT = 500,
		INTERACTION_CANCELED_BEFORE_TAKING = 400,
		INTERACTION_NOT_FOUND = 404,
		INTERACTION_NOT_TAKEN = 400,
		CANNOT_DISPATCH_MAIL = 500,
		--take interaction
		INTERACTION_CLOSED_OR_TAKEN = 400,
		INTERACTION_CLOSED_FROM_PROXY = 400,
		--take del im
		CONVERSATION_DOES_NOT_EXISTS = 404,
		BUDDY_IS_OFFLINE = 400,
		NO_BUDDY = 400,
		FAILED_TO_CREATE_IM_ACCOUNT = 500,
		--facebook
		MISSING_FIELD = 400,
		IRSERVER_ERROR = 500,
		--requeue
		LABEL_PENDING_IN_USE = 400,
		LABEL_PENDING_IN_INTERACTION = 400,
		INTERACTION_NOT_TAKEN_BY_AGENT = 400,
		COULD_NOT_RESERVE_AGENT = 400,
		--generic
		INTERNAL_ERROR = 500,
		PROXY_ERROR = 500,
		FAIL = 500,
		OK = 200
	}
	return mapping[result_code] or 400 -- nginx will retry request if status is 500
end
