local m_moduleLocation = select(2, ...)
local _, m_widgetId = m_moduleLocation:match("(.*/)(.*)") -- sample
module(..., package.seeall)

LogInfo("[INTEGRATIONS.%s.api] Starting API Module .... ", m_widgetId)

local function Initialize (urlParameters)
	LogInfo("[INTEGRATIONS.%s.api] Initialize API . urlParameters: %s.", m_widgetId, urlParameters)

	local initialData = {
		dataEjemplo1 = "nombre1111",
		otrosEjemplos = {
			name = "nombre1111",
			list1 = {
				{number = 1},
				{number = 2}
			},
			list2 = {
				{number = 1},
				{number = 2}
			}
		}
	}

	return initialData
end

return {
	Initialize = Initialize
}
