module(..., package.seeall)
local utils = require "shared.apps.utils"
local m_datasource

function GetName ()
	return "Skills"
end

function GetDefinition (datasource)
	m_datasource = datasource
	return _M
end

function GetSkills (vcc, skillId, keyspace)
	local skills = utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "VCCSkills",
		superColumns = true,
		key = vcc,
		columns = skillId and {skillId} or {}
	}
	if skillId then
		return skills and skills[skillId] or {}
	else
		return skills or {}
	end
end
