/*jshint quotmark:false*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snPostsCreate) {
	inConcert.snPostsCreate = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function CreatePopup (account)
	{
		CreatePopup.uber.constructor.call(this, account);
	}
	
	inConcert.Utils.inherit(CreatePopup, inConcert.snPostsCreate.base);
	if (typeof inConcert.snPostsCreate.instagram !== "function") {
		inConcert.snPostsCreate.instagram = CreatePopup;
	}
	
	CreatePopup.prototype.__getAvailableContentTypes = function() {
		return {
			link : true,
			image : {
				link : true,
				disk : true
			}
		};
	};
	
	CreatePopup.prototype.__getMaxFileSizeMB = function() {
		return 10;
	};
	
	CreatePopup.prototype.__getClassName = function() {
		return "instagramPost";
	};
	
	CreatePopup.prototype.__addText = function(data) {
		var text = this.__getText();
		data.message = text;
	};
	
	CreatePopup.prototype.__addLinkToData = function(data, link, isImage) {
		data.link = link;
		if (isImage) {
			data.image = true;
		}
	};

}());