/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function TotalList ()
	{
		TotalList.uber.constructor.call(this);
		this.batch_actions = [
			"REOPEN",
			"PAUSE",
			"RESUME",
			"SET_ATTRIBUTES",
			"CLOSE"
		];
	}

	inConcert.Utils.inherit(TotalList, inConcert.snPostsList.base);
	if (typeof inConcert.snPostsList.total !== "function") {
		inConcert.snPostsList.total = TotalList;
	}

	TotalList.prototype.HasPermission = function(campaign) {
		return  inConcert.app.getSNPostsManager().HasPermission(campaign, "sn_active_posts") || inConcert.app.getSNPostsManager().HasPermission(campaign, "sn_posts_history") || inConcert.app.getSNPostsManager().HasPermission(campaign, "sn_scheduled_posts");
	};

	TotalList.prototype.__getPermission = function() {
		return "sn_active_posts";
	};

	TotalList.prototype.GetView = function() {
		return "TOTAL";
	};

	TotalList.prototype.RetrieveType = function() {
		let retrieveType = inConcert.social_networks.getSelectedTabId();
		return retrieveType;
	};

	TotalList.prototype.GetName = function() {
		return "<%=_T('Total')%>";
	};

	TotalList.prototype.GetDescription = function() {
		return "<%=_T('Total')%>";
	};

	TotalList.prototype.GetClassName = function() {
		return "categoryTotal";
	};
}());