/*jshint quotmark:false*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.snStatistics) {
	inConcert.snStatistics = {};
}
if (!inConcert.snStatistics.account) {
	inConcert.snStatistics.account = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	var definition = [
		{
			id : "likes",
			name : "<%=_T('Page likes')%>",
			description : "<%=_T('Number of page likes.')%>"
		}
	];

	function Statistics (rawData)
	{
		var slices = [
			inConcert.snStatisticsSlices.today,
			inConcert.snStatisticsSlices.yesterday,
			inConcert.snStatisticsSlices.last7days,
			inConcert.snStatisticsSlices.last28days,
			inConcert.snStatisticsSlices.total
		];
		Statistics.uber.constructor.call(this, definition, slices, inConcert.snStatisticsSlices.last7days, rawData);
	}
	
	inConcert.Utils.inherit(Statistics, inConcert.snStatistics.account.base);
	if (typeof inConcert.snStatistics.account.facebook !== "function") {
		inConcert.snStatistics.account.facebook = Statistics;
	}
	
	Statistics.prototype.GetClassName = function() {
		return "fbPost";
	};

}());