module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

function GetName()
	return "Configuration"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function Save(userAtVcc, configuration, keyspace)
	utils.SaveRows {
		keyspace = keyspace or "Agent",
		columnFamily = "SupervisorConfig",
		rows = {
			[userAtVcc] = configuration,
		}
	}
end

function Get(userAtVcc, keyspace)
	return utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "SupervisorConfig",
		key = userAtVcc,
	} or {}
end
