--[[
    Con el FLAG "m_luisApiVersion" indicamos la versión de LUIS a utilizar.
    El mismo puede ser modificado únicamente por Fábrica o TQA para validar pruebas entre las diferentes versiones.
]]--

--local m_luisApiVersion = "2.0" -- VERSION CON LA CUAL HEMOS INTEGRADO LUIS POR PRIMERA VEZ CON I6. 
-- Ahora la versión es un atributo de cada aplicación, ya no se define aquí 

local m_apiLuis = require("luis"):new() -- rocka

module(..., package.seeall)

function GetAPI ()
    return m_apiLuis
end
