local model_perm = require "shared.permissions.models.permissions"

module(..., package.seeall, inconcert.orbit.application.Decorate)

local utils = require "shared.apps.utils"
m_htmlRender = nil

function MapUris (module, htmlRender, prefix)
	local LogRequest = require("apps.agent.requestFilters").LogRequest
	prefix = prefix or ""

	module:dispatch_get( utils.JsonReply .. LogRequest .. GetPermissions, prefix .. "/load_user_permissions/"   )
	m_htmlRender = htmlRender
end

function GetPermissions (web)
	return model_perm.GetLoggedUserPermissions()
end
