local m_definitions = {
	basic = {
		isSimple = false,
		--getEntity = nil, -- custom function con la cual podemos obtener la entidad segun el JSON o tabla LUA.
		fields = {
			{
				field_id = "Name",
				validations = {
					id = "Only letters, numbers, dashes and dots are allowed in the skill Name.",
					html_malicious_code = "Possible malicious code in the skill Name"
				}
			},
			{
				field_id = "Description",
				validations = {
					html_malicious_code = "Possible malicious code in the skill Description."
				}
			},
			{
				field_id = "DefaultValue",
				validations = {
					html_malicious_code = "Possible malicious code in the skill Default Value."
				}
			}
		}
	}
}

return {
	GetDefinitions = function() return m_definitions end
}
