local m_definitions = {
	basic = {
		isSimple = false,
		--getEntity = nil, -- custom function con la cual podemos obtener la entidad segun el JSON o tabla LUA.
		fields = {
			{
				field_id = "Id",
				validations = {
					id = "Only letters, numbers, dashes and dots are allowed in the user Id.",
					html_malicious_code = "Possible malicious code in the user Id."
				}
			},
			{
				field_id = "FirstSurname",
				validations = {
					html_malicious_code = "Possible malicious code in the user First Surname."
				}
			},
			{
				field_id = "Name",
				validations = {
					html_malicious_code = "Possible malicious code in the user first Name."
				}
			},
			{
				field_id = "UserGroup",
				validations = {
					html_malicious_code = "Possible malicious code in the user Permission."
				}
			}
		}
	}
}

return {
	GetDefinitions = function() return m_definitions end
}
