module(..., package.seeall, inconcert.orbit.application.Decorate)

local models = require("apps.agent.model"):GetModels()
m_htmlRender = nil

local function LoadAllCodes (web)
	LogInfo("[AGENT.TELEPHONES:LoadAllCodes] Retrieving telephones codes %s on vcc %s", inconcert.authUser.userName, inconcert.authUser.virtualContactCenter)
	local _, jsonCountries = models.Countries.FindAll()
	web:content_type("application/json")
	return jsonCountries
end

function GetAllCodes ()
	local countries = models.Countries.FindAll()
	return countries
end

function MapUris (module, htmlRender, prefix)
	local LogRequest = require("apps.agent.requestFilters").LogRequest
	module:dispatch_get( LogRequest .. LoadAllCodes, prefix .. "/codes/find_all/([^.]*)" )
	m_htmlRender = htmlRender
end
