local models = require("apps.agent.model"):GetModels()

module(..., package.seeall, inconcert.orbit.application.Decorate)

m_htmlRender = nil

function MapUris (module, htmlRender, prefix)
	local LogRequest = require("apps.agent.requestFilters").LogRequest
	module:dispatch_get( LogRequest .. GetAllTimezones, prefix.."/find_all/([^.]*)")
	
	m_htmlRender = htmlRender
end

function GetAllTimezones (web)
	local vcc = inconcert.authUser.virtualContactCenter
	local name = inconcert.authUser.userName
	
	LogInfo("Retrieving available timezones %s on vcc %s", name, vcc)
	
	local timezones = models.Timezones.FindAll()

	web.headers["Content-Type"] = "application/json"
	return json.encode(timezones)
end

