/*jslint evil:true nomen:false regexp: false*/
/*global $, jQuery, window, inConcert, air

*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {

	/**
	Class AnalyticsWindow.
	*/
	function AnalyticsWindow(options) {
		window.id = "AnalyticsWindow";
		AnalyticsWindow.uber.constructor.call(this,
								{ move : ["analyticsWrapperHeader", "analyticsWrapperFooter"],
									resizer : "resizeGripperArea"
								}, options);

		this.setHorizontalResizingLimits(1240);
		$("#navigationFrame").append('<iframe src="about:blank" width="100%" height="100%" frameborder="0" scrolling="no" id="analyticsApplication"></iframe>');
		var url = inConcert.app.getProtocol() + "://i6-analytics.inconcertcc.com/inconcert/apps/analytics/dashboards/open/home/filter?style=skindark";
		$("#analyticsApplication").attr("src", url);
	}

	inConcert.Utils.inherit(AnalyticsWindow, inConcert.Window);

	//when jquery says so, start it all up
	$(document).ready(function() {
		inConcert.i18n.updateScreen();
		window.onReady(inConcert, window);
		var analyticsWindow = new AnalyticsWindow();
	});

}());
