/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */
/* global icc */

//this.inConcert = this.inConcert || {};
//this.inConcert.app_monitoring = this.inConcert.app_monitoring || {};
/*
    /// instalacion de node js
    apt-get -y remove nodejs

    cd /usr/bin
    wget https://nodejs.org/dist/v16.16.0/node-v16.16.0-linux-x64.tar.xz
    tar -xvf node-v16.16.0-linux-x64.tar.xz
    ln node-v16.16.0-linux-x64/bin/node .
    ln node-v16.16.0-linux-x64/lib/node_modules/npm/bin/npm-cli.js npm -s
    ln /usr/bin/node-v16.16.0-linux-x64/lib/node_modules/npm/bin/npx-cli.js npx -s
    // angular
    cd /usr/lib/inconcert/agent/angular_projects/occ-agent
    ./build.sh /usr/lib/inconcert/agent/
  

   
  nginx 
  solo para desarrollo
  /opt/
  location /ng-dev/ {
                rewrite /ng-dev/(.*) /$1  break;
                proxy_pass         http://localhost:4200;
  }
  location /ng-cli-ws/ {
             proxy_pass         http://localhost:4200;
             proxy_http_version 1.1;
             proxy_set_header Upgrade $http_upgrade;
             proxy_set_header Connection 'upgrade';
             proxy_set_header Host $host;
             proxy_cache_bypass $http_upgrade;

  }
  Para la recarga de componentes si perder datos pasados mediante bindings en javascript se 
  puede implementar los siguentes metodo para persistir los datos y volver a inicializar.
  Solo usado en desarrollo y no tiene efecto ninguno en produccion.

   @Input() getReloadState: Function = ()=>{
    return {campaign:this.campaign}   ; la campaña fue obtenida mediante un binding en javascript externo
                                      ; la devolvemos al loader 
  }
  @Input() setReloadState: Function = (state: any) => {
     this.campaign = state.campaign;  ; El loader recarga la nueva instancia del componente y nos da
                                      ; los datos obtenidos del metodo anterior , reinicializamos la data
                                      ; del componente
  }
  

*/



(function () {
    "use strict";
    const url_dev = "/ng-dev";
    const DEVELOPMENT = false; //No tocar, el script dev-start cambia esto por true

    const PARTIAL_RELOAD_BTN = false; // enciende el boton que no recarga todas las veces estos archivos de CACHED
    const CACHED = {"main.js":true,"polyfills.js":true,"runtime.js":true}
    const RESOURCES = [
        "polyfills.js",
        "runtime.js",
        "styles.css",


        "default-node_modules_chart_js_dist_chart_js.js",
        "default-node_modules_ngx-translate_http-loader_dist_fesm2022_ngx-translate-http-loader_mjs-no-944358.js",
        "default-node_modules_angular_platform-browser_fesm2022_animations_mjs.js",
        "common.js",
        "src_modules_agent_agent_module_ts.js",
        "src_modules_agent-monitoring_agent-monitoring_module_ts.js",


        "src_modules_provisioning_provisioning_module_ts.js",
        "src_modules_supervisor_supervisor_module_ts.js",
        "src_modules_administration_administration_module_ts.js",


        "main.js",

    ];

    function OCCLoader() {
        this.scripts = {}
        const occagentcss = document.getElementById('occ-agent.css');
        if(occagentcss)
            occagentcss.remove();
        this.loadResources().then(() => {
            rid++;
        });
    }
    OCCLoader.prototype.clearPreloadedFlag = function () {
        window.icc = window.icc || {}
        window.icc['preloaded-modules'] = window.icc['preloaded-modules'] || {}

        if (window.icc && window.icc['preloaded-modules']) {
            for (let moduleName in window.icc['preloaded-modules']) {
                if (window.icc['preloaded-modules'].hasOwnProperty(moduleName)) {
                    window.icc['preloaded-modules'][moduleName].bootstrapped = false;
                }
            }
        }

    }
    OCCLoader.prototype.loadResource = async function (resource) {
        switch (resource.split(".").pop()) {
            case "js":
                return await this.loadJs(resource);
            case "css":
                return await this.loadCss(resource);
        }
    };

    OCCLoader.prototype.loadResources = async function () {
        this.loadeds = this.loadeds || {}

        for (let k = 0; k < RESOURCES.length; k++) {
            const resource = RESOURCES[k];
            const name = resource.name || resource;
            const once = resource.once || false;
            if (once && this.loadeds[name])
                continue;
            try {
                await this.loadResource(name)
                this.loadeds[name] = true;
            } catch (err) {
                this.loadeds[name] = false;
                console.log(err)
            }

        }
    };
    let rid = 0;
    OCCLoader.prototype.loadJs2 = async function (name) {
        return new Promise((resolve, reject) => {
            let url = url_dev + "/" + name + '?_=' + rid;
            var script = document.createElement('script');
            script.type = 'text/javascript';

            // Lógica para verificar si el script se cargó correctamente
            if (script.readyState) {  // IE
                script.onreadystatechange = function () {
                    if (script.readyState === 'loaded' || script.readyState === 'complete') {
                        script.onreadystatechange = null;
                        resolve();
                    }
                };
            } else {  // Otros navegadores
                script.onload = function () {
                    resolve();
                };
            }

            script.src = url;
            document.getElementsByTagName('head')[0].appendChild(script);
        })
    }
    OCCLoader.prototype.loadJs = async function (name) {
        if (this.partialReload && CACHED[name] && this.scripts[name]) {
            return new Promise((resolve, reject) => {
                eval(this.scripts[name])
                resolve()
            })
        } else {
            return new Promise((resolve, reject) => {
                let url = url_dev + "/" + name;
                $.ajaxSetup({
                    cache: false
                });
                $.getScript(url)
                    .done((script, textStatus) => {
                        this.scripts[name]=script
                        resolve();
                    })
                    .fail((jqxhr, settings, exception) => {
                        /*jshint unused:false*/
                        reject();
                    });
            });
        }
    };
    OCCLoader.prototype.loadCss = function (name) {
        return new Promise((resolve, reject) => {
            /*jshint unused:false*/
            const dcss = document.getElementById(name);
            if(dcss)
                dcss.remove();
            let url = url_dev + "/" + name;
            let styleLink = document.createElement("link");
            styleLink.setAttribute("id",name);
            styleLink.setAttribute("rel", "stylesheet");
            styleLink.setAttribute("type", "text/css");
            styleLink.setAttribute("href", url);
            document.getElementsByTagName("head")[0].appendChild(styleLink);
            resolve();
        });
    };
    OCCLoader.prototype.makeReloadButton = function () {
        var reloadBtn = document.createElement("button");
        reloadBtn.innerHTML = "<i class='far fa-sync'></i>";
        reloadBtn.className = "reloadButton";
        reloadBtn.style.position = "absolute";
        reloadBtn.style.zIndex = 100000;
        reloadBtn.style.left = "150px";
        reloadBtn.style.top = "10px";
        reloadBtn.title = "Full Reload";

        reloadBtn.onclick = async () => {
            reloadBtn.disabled =true;
            window.icc.loader.occ_bundle = null;
            this.partialReload = false

            await this.__refresh_development();
            reloadBtn.disabled =false;

        };
        document.body.appendChild(reloadBtn);

    }
    OCCLoader.prototype.makePartialReloadButton = function () {
        var reloadBtn = document.createElement("button");
        reloadBtn.innerHTML = "<i class='fad fa-sync'></i>";
        reloadBtn.className = "reloadButton";
        reloadBtn.style.position = "absolute";
        reloadBtn.style.zIndex = 100000;
        reloadBtn.style.left = "184px";
        reloadBtn.style.top = "10px";
        reloadBtn.title = "Partial Reload";

        reloadBtn.onclick = async () => {
            window.icc.loader.occ_bundle = null;
            this.partialReload = true;
            reloadBtn.disabled = true;
            await this.__refresh_development();
            reloadBtn.disabled = false;

        };
        document.body.appendChild(reloadBtn);

    }

    OCCLoader.prototype.__refresh_development = async function () {

        /* ESTO HAY QUE MIRAR main.js que sale del ng serve a ver como se llama */

        window.webpackChunkocc_agent = null; // clear app in memory
        if (window.icc && window.icc.loader && window.icc.loader.occ_bundle) { // esta jerarquia se crea en el main.ts 
            window.icc.loader.occ_bundle = null;
        }
        await this.loadResources();
        rid++;
        let it = setInterval(() => {
            if (window.icc && window.icc.loader && window.icc.loader.occ_bundle) { // espera a que carguen los javascript
                this.clearPreloadedFlag()
                clearInterval(it);
            }
        }, 200);
    };

    // globals
    if (DEVELOPMENT && !window.occ_loader_loaded) {
        window.occ_agent_loader_loaded = true;
        let loader = new OCCLoader();
        window.loadAngularReloadButton = () => loader.makeReloadButton();
        if(PARTIAL_RELOAD_BTN)
            window.loadPartialAngularReloadButton = () => loader.makePartialReloadButton();
        window.iccWebComponentsInstanceId = {

        };
        window.iccWebComponentsClassPtr = {

        }
        window.iccRefreshCustomComponents = (lname, cname) => {

            let components = document.querySelectorAll('[data-icc-dev-component=true]')
            for (let i = 0; i < components.length; i++) {
                let component = components[i];
                let localname = component.localName.replace(/_+$/, "");
                if (localname == lname) {
                    console.log("REBUILD COMPONENT ", cname)
                    let parent = component.parentNode;
                    let newcomponent = document.createElement(cname);
                    newcomponent.setAttribute("data-icc-dev-component", true)
                    newcomponent.id = component.id;
                    let paramNames = [];
                    if (component.hasAttribute("data-icc-dev-params")) {
                        newcomponent.setAttribute("data-icc-dev-params", component.getAttribute("data-icc-dev-params"));
                        paramNames = (component.getAttribute("data-icc-dev-params") || "").split(",");
                    }

                    for (let p = 0; p < paramNames.length; p++) {
                        if (component.hasAttribute(paramNames[p])) {
                            newcomponent.setAttribute(paramNames[p], component.getAttribute(paramNames[p]));
                        }
                    }
                    parent.replaceChild(newcomponent, component)
                    if (component.getReloadState && newcomponent.setReloadState) {
                        newcomponent.setReloadState(component.getReloadState())
                    }
                }
            }
        }

    }


})();


