/*jslint evil:true nomen:false regexp: false*/
/*global $, jQuery, window, inConcert, InconcertChat

*/

function f(number) {
	if (number < 10) {
		return "0"  + number;
	}
	else {
		return number + '';
	}
}

function timer() {
	$.ajax({
		url : "/inconcert/apps/analytics/ping",
		type: 'POST',
		dataType: "json",
		contentType: "application/json",
		data : JSON.stringify({}),
		success: function(res) {
			setTimeout(function() {
				timer();
			}, 2000);
		},
		error: function(a,b,c) {
		}
	})
}

$(document).ready(function() {
	timer();
	var now = new Date();
	var startDate = now.getUTCFullYear() + "-" + f(now.getUTCMonth() + 1) + "-" + f(now.getUTCDate());
	var endDate = now.getUTCFullYear() + "-" + f(now.getUTCMonth() + 1) + "-" + f(now.getUTCDate() + 1);
	$("#startDate").val(startDate).datepick({dateFormat: 'yyyy-mm-dd'});
	$("#endDate").val(endDate).datepick({dateFormat: 'yyyy-mm-dd'});
	$("#filterForm").submit(function() {
		var startDate = $("#startDate").val();
		var endDate = $("#endDate").val();
		var filter = "";
		if (startDate !== "" || endDate !== "") {
			filter = 'filter?output=render'
			if (startDate !== "") {
				filter += "&startDate=" + startDate;
			}
			if (endDate !== "") {
				filter += "&endDate=" + endDate;
			}
		}
		if ($("#optConversations").prop("checked") || $("#optMailConversations").prop("checked") 
			|| $("#optChatSummary").prop("checked") || $("#optMailSummary").prop("checked") || $("#optSMSSummary").prop("checked")) {
			var campaign = $("#campaign").val();
			if (!campaign || campaign === "") {
				alert("Please select the campaign!");
				return false;
			}
			var operation;
			if ($("#optMailConversations").prop("checked")) {
				operation = "mail_conversations";
			}
			else {
				if ($("#optChatSummary").prop("checked")) {
					operation = "chat_summary";
				}
				else {
					if ($("#optSMSSummary").prop("checked")) {
						operation = "sms_summary";
					}
					else {
						if ($("#optMailSummary").prop("checked")) {
							operation = "mail_summary";
						}
						else {
							operation = "conversations";
						}
					}
				}
			}
			window.location.href = '/inconcert/apps/analytics/' + operation + "/" + campaign + "/" + filter;
		}
		else {
			if ($("#exportStateDetail").prop("checked")) {
				window.location.href = '/inconcert/apps/analytics/agent_states/' + filter;
			}
			else {
				window.location.href = '/inconcert/apps/analytics/agent_states_summary/' + filter;
			}
		}
		return false;
	});
	
	$("#optConversations").click(function() {
		if ($("#optConversations").prop("checked")) {
			$("#statesSection").hide();
			$("#optStateChanges").prop("checked", false);
			$("#optMailConversations").prop("checked", false);
			$("#optChatSummary").prop("checked", false);
			$("#optSMSSummary").prop("checked", false);
			$("#optMailSummary").prop("checked", false);
			$("#campaignSection").show();
		}
	});
	$("#optMailConversations").click(function() {
		if ($("#optMailConversations").prop("checked")) {
			$("#statesSection").hide();
			$("#optStateChanges").prop("checked", false);
			$("#optConversations").prop("checked", false);
			$("#optChatSummary").prop("checked", false);
			$("#optMailSummary").prop("checked", false);
			$("#optSMSSummary").prop("checked", false);
			$("#campaignSection").show();
		}
	});
	$("#optStateChanges").click(function() {
		if ($("#optStateChanges").prop("checked")) {
			$("#statesSection").show();
			$("#optConversations").prop("checked", false);
			$("#optMailConversations").prop("checked", false);
			$("#optChatSummary").prop("checked", false);
			$("#optMailSummary").prop("checked", false);
			$("#optSMSSummary").prop("checked", false);
			$("#campaignSection").hide();
		}
	});
	$("#optChatSummary").click(function() {
		if ($("#optChatSummary").prop("checked")) {
			$("#statesSection").hide();
			$("#optConversations").prop("checked", false);
			$("#optMailConversations").prop("checked", false);
			$("#optStateChanges").prop("checked", false);
			$("#optMailSummary").prop("checked", false);
			$("#optSMSSummary").prop("checked", false);
			$("#campaignSection").show();
		}
	});
	$("#optSMSSummary").click(function() {
		if ($("#optSMSSummary").prop("checked")) {
			$("#statesSection").hide();
			$("#optConversations").prop("checked", false);
			$("#optMailConversations").prop("checked", false);
			$("#optStateChanges").prop("checked", false);
			$("#optChatSummary").prop("checked", false);
			$("#optMailSummary").prop("checked", false);
			$("#campaignSection").show();
		}
	});
	$("#optMailSummary").click(function() {
		if ($("#optMailSummary").prop("checked")) {
			$("#statesSection").hide();
			$("#optConversations").prop("checked", false);
			$("#optMailConversations").prop("checked", false);
			$("#optStateChanges").prop("checked", false);
			$("#optSMSSummary").prop("checked", false);
			$("#optChatSummary").prop("checked", false);
			$("#campaignSection").show();
		}
	});
	
	
	
})
