/*  jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
  strict:true, undef:true, unused:true, curly:true, browser:true, indent:false, maxerr:50, esversion: 11 */

/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

if (!inConcert.batchManagementAddresses) {
	inConcert.batchManagementAddresses = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function AddressesMailPopup (batch)
	{
		AddressesMailPopup.uber.constructor.call(this, batch);
	}

	inConcert.Utils.inherit(AddressesMailPopup, inConcert.batchManagementAddresses.base);
	
	if (typeof inConcert.batchManagementAddresses.mail !== "function") {
		inConcert.batchManagementAddresses.mail = AddressesMailPopup;
	}

	AddressesMailPopup.prototype.__getClassName = function() {
		return "mailBatch";
	};

	AddressesMailPopup.prototype.__getAndValidateAddress = function(address_t) {
		return inConcert.Utils.validate(address_t, "email").success? address_t : false;
	};

}());