/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function ArchiveList ()
	{
		ArchiveList.uber.constructor.call(this);
		this.batch_actions = [
			"REOPEN"
		];
	}

	inConcert.Utils.inherit(ArchiveList, inConcert.batchManagementList.base);
	if (typeof inConcert.batchManagementList.archive !== "function") {
		inConcert.batchManagementList.archive = ArchiveList;
	}

	ArchiveList.prototype.__getPermission = function() {
		return "batches_history";
	};

	ArchiveList.prototype.GetView = function() {
		return "ARCHIVE";
	};

	ArchiveList.prototype.RetrieveType = function() {
		return "ARCHIVE";
	};

	ArchiveList.prototype.GetName = function() {
		return "<%=_T('Archive')%>";
	};

	ArchiveList.prototype.GetDescription = function() {
		return "<%=_T('Archived batches (include deleted)')%>";
	};

	ArchiveList.prototype.GetClassName = function() {
		return "categoryArchived";
	};

	ArchiveList.prototype.HasDisabledBatchActions = function() {
		return true;
	};
}());