module(..., package.seeall)

local utils = require "shared.apps.utils"
local m_datasource

function GetName()
	return "Indicators"
end

function GetDefinition(datasource)
	m_datasource = datasource
	return _M
end

function GetMetadata(keyspace)
	return utils.GetAllColumns {
		keyspace = keyspace or "Agent",
		columnFamily = "CampaignAnalyticsMetadata",
		superColumns = true,
		key = "system",
		columns = {}
	} or {}
end
