
local function MakeExecutable (stateName, activityId, data, aux)
	if aux.empty(data.ip) or aux.empty(data.port) or aux.empty(data.vcc) or aux.empty(data.state) then
		return aux.invalidParameterActivity(stateName, activityId, "invalid data")
	end
	local text = ""
	--call method
	text = text .. string.format("local _result = ExecuteFlowState(%s, %s, %s, %s, %s, %s)", 
		data.vcc, data.state, data.ip, data.port, tostring(data.ssl or false), not aux.empty(data.data) and data.data or "nil")
	text = text .. '\n_result = { status = _result.status and _result.code == 0 or false, data = _result.status and _result.code == 0 and _result.data or _result.message or "" }'
	text = text .. '\nlogTrace("DEBUG", string.format("Processing activity (end) result: %s", json.encode(_result)))'
	--process result
	if not aux.empty(data.result) then
		text = text .. string.format('\n%s = _result', data.result)
	end
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
