
local function MakeExecutable (stateName, activityId, data, aux)
	data.destination = data.destination or "contact_center"
	local text = string.format(
		"local _request = { " .. 
			"campaignAtVCC = %s, " .. 
			"account = %s, " .. 
			"contact = { " ..
				"externalId = %s, " ..
				"name = %s, " ..
				"addresses = %s, " ..
			" }, " .. 
			"reportingGroup = %s, " .. 
			"reportingData = %s, " .. 
			"agentData = %s" ..
		"}",
		aux.valueOrNil(data.toCampaign),
		aux.valueOrNil(data.toAccount),
		aux.valueOrNil(data.externalId),
		aux.valueOrNil(data.name),
		aux.valueOrNil(data.addresses),
		aux.valueOrNil(data.reportingGroup),
		aux.valueOrNil(data.reportingData),
		aux.valueOrNil(data.agentData)
	)
	text = text .. "\nlocal _result = StartWebcontact(__vccName, _request)"
	text = text .. '\nlogTrace("DEBUG", string.format("Processing activity (end) result: %s", json.encode(_result)))'
	if not aux.empty(data.result) then
		text = text .. string.format('\n%s = _result', data.result)
	end
	return 200, text
end

return {
	MakeExecutable = MakeExecutable
}
