/* jshint forin:true, noarg:true, jquery:true, noempty:true, eqeqeq:true, bitwise:true,
	strict:true, undef:true, unused:vars, curly:true, browser:true, indent:false, maxerr:50, quotmark:double */

/* global inConcert */

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
	//"use strict";

//message types

	if (!inConcert.adm_process_flow_messages_type.chat) {
		inConcert.adm_process_flow_messages_type.chat = {
			text : inConcert.adm_process_flow_messages_type.base.text,
			attachment : inConcert.adm_process_flow_messages_type.base.attachment,
			gallery : inConcert.adm_process_flow_messages_type.base.gallery,
			list : inConcert.adm_process_flow_messages_type.base.list,
			geo: inConcert.adm_process_flow_messages_type.base.geo,
		};
	}

	if (!inConcert.adm_process_flow_messages_type.chat_sorted) {
		inConcert.adm_process_flow_messages_type.chat_sorted = [
			"text",
			"attachment",
			"gallery",
			"list",
			"geo"
		];
	}

//button types

	if (!inConcert.adm_process_flow_messages_button.chat) {
		inConcert.adm_process_flow_messages_button.chat = {
			list : inConcert.adm_process_flow_messages_button.base.base,
			gallery : inConcert.adm_process_flow_messages_button.base.base
		};
	}

//quick replies

	function adm_process_flow_messages_quickreply(parent, data, $list) {
		adm_process_flow_messages_quickreply.uber.constructor.call(this, parent, data, $list);

		this.types = [
			{
				id : "text",
				name : "<%=_T('Text')%>",
				description : "<%=_T('Suggests a text option.')%>"
			}
		];
	}

	inConcert.Utils.inherit( adm_process_flow_messages_quickreply, inConcert.adm_process_flow_messages_quickreply.base );

	if (typeof inConcert.adm_process_flow_messages_quickreply.chat !== "function") {
		inConcert.adm_process_flow_messages_quickreply.chat = adm_process_flow_messages_quickreply;
	}

//clase

	function adm_process_flow_messages(activity) {
		adm_process_flow_messages.uber.constructor.call(this, activity);
		if (activity.data.type === "ask_for_help") {
            inConcert.adm_process_flow_messages_type.chat_sorted = [
                "text"
            ];
        }
	}

	inConcert.Utils.inherit( adm_process_flow_messages, inConcert.adm_process_flow_messages.base );

	if (typeof inConcert.adm_process_flow_messages.chat !== "function") {
		inConcert.adm_process_flow_messages.chat = adm_process_flow_messages;
	}

}());
