local utils = require "shared.apps.utils"
module(..., package.seeall, inconcert.orbit.application.Decorate)

--------------------------------------------------------------------------------------
local m_migration = {}
local m_migrationsSteps = {}

--------------------------------------------------------------------------------------
-- STEP PROVISIONING - PEERS ------
--------------------------------------------------------------------------------------

local m_peersStep = {
	id = "peers",
	description = "Peers Step Module Migration"
}

--[[

]]--
m_peersStep.Start = function(info)
	LogInfo("[PROVISIONING.MIGRATIONS.PEERS.Start] Start Migration Peers for vcc '%s'.", info.vccId)

	--[[
		------------------------------------------------------------------------------
		IMPLEMENTACION (A MEDIAS) para la importacion de peers desde Allegro a OCC
		------------------------------------------------------------------------------
	]]--
	-- local allegroPeers = info.allegroInfo.VCCIpPeers or {}
	-- LogDebug("[PROVISIONING.MIGRATIONS.PEERS.Start] --> VCCIpPeers '%s'.", utils.JSON_Encode(allegroPeers))
	-- if not next(allegroPeers) then
	-- 	LogInfo("[PROVISIONING.MIGRATIONS.PEERS.Start] VCC %s has not configured Peers.", info.vccId)
	-- 	return false
	-- end
	-- -- recorro los peers y
	-- local peersModule = utils.GetControllerOthersApps("provisioning", {controllerName = "peers", modelName = nil})
	-- for _, allegroPeer in ipairs(allegroPeers) do
	-- 	local success, res = peersModule.ImportAllegroPeer(allegroPeer)
	-- end
	------------------------------------------------------------------------------
	-- ok
	return true
end

--[[

]]--
m_peersStep.Rollback = function(info)
	LogInfo("[PROVISIONING.MIGRATIONS.PEERS.Rollback] Rollback Migration Peers for vcc '%s'.", info.vccId)
	-- ok
	return true
end

table.insert(m_migrationsSteps, m_peersStep) -- agrego step al array
--------------------------------------------------------------------------------------

--[[

]]--
m_migration.GetSteps = function()
	return m_migrationsSteps
end

------------------------------------------
--
-- Exported functions
--
return {
	GetSteps = m_migration.GetSteps
}
