/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function ActiveList ()
	{
		ActiveList.uber.constructor.call(this);
		this.batch_actions = [
			"PAUSE",
			"RESUME",
			"SET_ATTRIBUTES",
			"CLOSE"
		];
	}

	inConcert.Utils.inherit(ActiveList, inConcert.snPostsList.base);
	if (typeof inConcert.snPostsList.active !== "function") {
		inConcert.snPostsList.active = ActiveList;
	}
	
	ActiveList.prototype.__getPermission = function() {
		return "sn_active_posts";
	};

	ActiveList.prototype.GetView = function() {
		return "ACTIVE";
	};

	ActiveList.prototype.RetrieveType = function() {
		return "ACTIVE";
	};

	ActiveList.prototype.GetName = function() {
		return "<%=_T('Active')%>";
	};

	ActiveList.prototype.GetDescription = function() {
		return "<%=_T('Active posts (include paused)')%>";
	};

	ActiveList.prototype.GetClassName = function() {
		return "categoryActive";
	};
}());