/*jshint quotmark:false, esversion: 11*/
/*global inConcert*/

if (!this.inConcert) {
	this.inConcert = {};
}

(function () {
/*jshint validthis:true*/
"use strict";

	function ScheduledList ()
	{
		ScheduledList.uber.constructor.call(this);
		this.batch_actions = [
			"PAUSE",
			"RESUME",
			"SET_ATTRIBUTES",
			"CLOSE"
		];
	}

	inConcert.Utils.inherit(ScheduledList, inConcert.snPostsList.base);
	if (typeof inConcert.snPostsList.scheduled !== "function") {
		inConcert.snPostsList.scheduled = ScheduledList;
	}

	ScheduledList.prototype.__getPermission = function() {
		return "sn_scheduled_posts";
	};
	
	ScheduledList.prototype.GetView = function() {
		return "SCHEDULED";
	};

	ScheduledList.prototype.RetrieveType = function() {
		return "SCHEDULED";
	};

	ScheduledList.prototype.GetName = function() {
		return "<%=_T('Scheduled')%>";
	};

	ScheduledList.prototype.GetDescription = function() {
		return "<%=_T('Scheduled posts')%>";
	};

	ScheduledList.prototype.GetClassName = function() {
		return "categoryScheduled";
	};

	ScheduledList.prototype.__getAvailableChannels = function() {
		return {
			FACEBOOK : true
		};
	};
}());