'use strict';
import BrowserMonitor from './BrowserMonitor';
import {setInterval,clearInterval,setTimeout,clearTimeout} from './utils';


let __icc__ = (function () {
    if (window.undefined == window.icc)
        window.icc = {};
 
    return window.icc
})();


(function (icc) {
   
    if (icc.bm === undefined) {
        icc.bm = {
            browserMonitor: BrowserMonitor,
            helpers: {setInterval,clearInterval,setTimeout,clearTimeout}
        }
    }
})(__icc__);





